/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.31.0-dev.20211126(d18d093403b12a65350c58a7b0d5771cc1f42aba)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var j=["require","exports","vs/base/common/platform","vs/base/common/strings","vs/editor/common/core/position","vs/editor/common/core/range","vs/base/common/event","vs/base/common/types","vs/base/common/errors","vs/base/common/lifecycle","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/uint","vs/base/common/uri","vs/editor/common/core/characterClassifier","vs/base/common/arrays","vs/base/common/diff/diffChange","vs/base/common/functional","vs/base/common/iterator","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/objects","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/core/token","vs/editor/common/diff/diffComputer","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/editor/common/model/wordHelper","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/modes/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/standalone/standaloneBase","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],G=function(I){for(var n=[],M=0,R=I.length;M<R;M++)n[M]=j[I[M]];return n},ge=this,me=typeof global=="object"?global:{},X;(function(I){I.global=ge;var n=function(){function M(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(M.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(M.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),M.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=M._isWindows(),this._isNode=typeof module!="undefined"&&!!module.exports,this._isElectronRenderer=typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="renderer",this._isWebWorker=typeof I.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process!="undefined"&&typeof process.versions!="undefined"&&typeof process.versions.electron!="undefined"&&process.type==="worker")},M._isWindows=function(){return typeof navigator!="undefined"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process!="undefined"?process.platform==="win32":!1},M}();I.Environment=n})(X||(X={}));var X;(function(I){var n=function(){function E(o,L,m){this.type=o,this.detail=L,this.timestamp=m}return E}();I.LoaderEvent=n;var M=function(){function E(o){this._events=[new n(1,"",o)]}return E.prototype.record=function(o,L){this._events.push(new n(o,L,I.Utilities.getHighPerformanceTimestamp()))},E.prototype.getEvents=function(){return this._events},E}();I.LoaderEventRecorder=M;var R=function(){function E(){}return E.prototype.record=function(o,L){},E.prototype.getEvents=function(){return[]},E.INSTANCE=new E,E}();I.NullLoaderEventRecorder=R})(X||(X={}));var X;(function(I){var n=function(){function M(){}return M.fileUriToFilePath=function(R,E){if(E=decodeURI(E).replace(/%23/g,"#"),R){if(/^file:\/\/\//.test(E))return E.substr(8);if(/^file:\/\//.test(E))return E.substr(5)}else if(/^file:\/\//.test(E))return E.substr(7);return E},M.startsWith=function(R,E){return R.length>=E.length&&R.substr(0,E.length)===E},M.endsWith=function(R,E){return R.length>=E.length&&R.substr(R.length-E.length)===E},M.containsQueryString=function(R){return/^[^\#]*\?/gi.test(R)},M.isAbsolutePath=function(R){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(R)},M.forEachProperty=function(R,E){if(R){var o=void 0;for(o in R)R.hasOwnProperty(o)&&E(o,R[o])}},M.isEmpty=function(R){var E=!0;return M.forEachProperty(R,function(){E=!1}),E},M.recursiveClone=function(R){if(!R||typeof R!="object"||R instanceof RegExp||!Array.isArray(R)&&Object.getPrototypeOf(R)!==Object.prototype)return R;var E=Array.isArray(R)?[]:{};return M.forEachProperty(R,function(o,L){L&&typeof L=="object"?E[o]=M.recursiveClone(L):E[o]=L}),E},M.generateAnonymousModule=function(){return"===anonymous"+M.NEXT_ANONYMOUS_ID+++"==="},M.isAnonymousModule=function(R){return M.startsWith(R,"===anonymous")},M.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=I.global.performance&&typeof I.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?I.global.performance.now():Date.now()},M.NEXT_ANONYMOUS_ID=1,M.PERFORMANCE_NOW_PROBED=!1,M.HAS_PERFORMANCE_NOW=!1,M}();I.Utilities=n})(X||(X={}));var X;(function(I){function n(E){if(E instanceof Error)return E;var o=new Error(E.message||String(E)||"Unknown Error");return E.stack&&(o.stack=E.stack),o}I.ensureError=n;var M=function(){function E(){}return E.validateConfigurationOptions=function(o){function L(u){if(u.phase==="loading"){console.error('Loading "'+u.moduleId+'" failed'),console.error(u),console.error("Here are the modules that depend on it:"),console.error(u.neededBy);return}if(u.phase==="factory"){console.error('The factory method of "'+u.moduleId+'" has thrown an exception'),console.error(u);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError=="undefined"&&(o.catchError=!1),typeof o.recordStats=="undefined"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=L),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(I.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags=="undefined"&&(o.preferScriptTags=!1),Array.isArray(o.nodeModules)||(o.nodeModules=[]),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){var m=n(new Error("INVALID cached data configuration, 'path' MUST be set"));m.phase="configuration",o.onError(m),o.nodeCachedData=void 0}return o},E.mergeConfigurationOptions=function(o,L){o===void 0&&(o=null),L===void 0&&(L=null);var m=I.Utilities.recursiveClone(L||{});return I.Utilities.forEachProperty(o,function(u,h){u==="ignoreDuplicateModules"&&typeof m.ignoreDuplicateModules!="undefined"?m.ignoreDuplicateModules=m.ignoreDuplicateModules.concat(h):u==="paths"&&typeof m.paths!="undefined"?I.Utilities.forEachProperty(h,function(C,e){return m.paths[C]=e}):u==="config"&&typeof m.config!="undefined"?I.Utilities.forEachProperty(h,function(C,e){return m.config[C]=e}):m[u]=I.Utilities.recursiveClone(h)}),E.validateConfigurationOptions(m)},E}();I.ConfigurationOptionsUtil=M;var R=function(){function E(o,L){if(this._env=o,this.options=M.mergeConfigurationOptions(L),this._createIgnoreDuplicateModulesMap(),this._createNodeModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""){if(this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var m=this.options.nodeRequire.main.filename,u=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,u+1)}if(this.options.nodeMain&&this._env.isNode){var m=this.options.nodeMain,u=Math.max(m.lastIndexOf("/"),m.lastIndexOf("\\"));this.options.baseUrl=m.substring(0,u+1)}}}return E.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0},E.prototype._createNodeModulesMap=function(){this.nodeModulesMap=Object.create(null);for(var o=0,L=this.options.nodeModules;o<L.length;o++){var m=L[o];this.nodeModulesMap[m]=!0}},E.prototype._createSortedPathsRules=function(){var o=this;this.sortedPathsRules=[],I.Utilities.forEachProperty(this.options.paths,function(L,m){Array.isArray(m)?o.sortedPathsRules.push({from:L,to:m}):o.sortedPathsRules.push({from:L,to:[m]})}),this.sortedPathsRules.sort(function(L,m){return m.from.length-L.from.length})},E.prototype.cloneAndMerge=function(o){return new E(this._env,M.mergeConfigurationOptions(o,this.options))},E.prototype.getOptionsLiteral=function(){return this.options},E.prototype._applyPaths=function(o){for(var L,m=0,u=this.sortedPathsRules.length;m<u;m++)if(L=this.sortedPathsRules[m],I.Utilities.startsWith(o,L.from)){for(var h=[],C=0,e=L.to.length;C<e;C++)h.push(L.to[C]+o.substr(L.from.length));return h}return[o]},E.prototype._addUrlArgsToUrl=function(o){return I.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs},E.prototype._addUrlArgsIfNecessaryToUrl=function(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o},E.prototype._addUrlArgsIfNecessaryToUrls=function(o){if(this.options.urlArgs)for(var L=0,m=o.length;L<m;L++)o[L]=this._addUrlArgsToUrl(o[L]);return o},E.prototype.moduleIdToPaths=function(o){if(this._env.isNode){var L=this.nodeModulesMap[o]===!0||this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o);if(L)return this.isBuild()?["empty:"]:["node|"+o]}var m=o,u;if(!I.Utilities.endsWith(m,".js")&&!I.Utilities.isAbsolutePath(m)){u=this._applyPaths(m);for(var h=0,C=u.length;h<C;h++)this.isBuild()&&u[h]==="empty:"||(I.Utilities.isAbsolutePath(u[h])||(u[h]=this.options.baseUrl+u[h]),!I.Utilities.endsWith(u[h],".js")&&!I.Utilities.containsQueryString(u[h])&&(u[h]=u[h]+".js"))}else!I.Utilities.endsWith(m,".js")&&!I.Utilities.containsQueryString(m)&&(m=m+".js"),u=[m];return this._addUrlArgsIfNecessaryToUrls(u)},E.prototype.requireToUrl=function(o){var L=o;return I.Utilities.isAbsolutePath(L)||(L=this._applyPaths(L)[0],I.Utilities.isAbsolutePath(L)||(L=this.options.baseUrl+L)),this._addUrlArgsIfNecessaryToUrl(L)},E.prototype.isBuild=function(){return this.options.isBuild},E.prototype.isDuplicateMessageIgnoredFor=function(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)},E.prototype.getConfigForModule=function(o){if(this.options.config)return this.options.config[o]},E.prototype.shouldCatchError=function(){return this.options.catchError},E.prototype.shouldRecordStats=function(){return this.options.recordStats},E.prototype.onError=function(o){this.options.onError(o)},E}();I.Configuration=R})(X||(X={}));var X;(function(I){var n=function(){function u(h){this._env=h,this._scriptLoader=null,this._callbackMap={}}return u.prototype.load=function(h,C,e,a){var d=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new E;else if(this._env.isElectronRenderer){var S=h.getConfig().getOptionsLiteral().preferScriptTags;S?this._scriptLoader=new M:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new M;var b={callback:e,errorback:a};if(this._callbackMap.hasOwnProperty(C)){this._callbackMap[C].push(b);return}this._callbackMap[C]=[b],this._scriptLoader.load(h,C,function(){return d.triggerCallback(C)},function(v){return d.triggerErrorback(C,v)})},u.prototype.triggerCallback=function(h){var C=this._callbackMap[h];delete this._callbackMap[h];for(var e=0;e<C.length;e++)C[e].callback()},u.prototype.triggerErrorback=function(h,C){var e=this._callbackMap[h];delete this._callbackMap[h];for(var a=0;a<e.length;a++)e[a].errorback(C)},u}(),M=function(){function u(){}return u.prototype.attachListeners=function(h,C,e){var a=function(){h.removeEventListener("load",d),h.removeEventListener("error",S)},d=function(b){a(),C()},S=function(b){a(),e(b)};h.addEventListener("load",d),h.addEventListener("error",S)},u.prototype.load=function(h,C,e,a){if(/^node\|/.test(C)){var d=h.getConfig().getOptionsLiteral(),S=L(h.getRecorder(),d.nodeRequire||I.global.nodeRequire),b=C.split("|"),v=null;try{v=S(b[1])}catch(i){a(i);return}h.enqueueDefineAnonymousModule([],function(){return v}),e()}else{var w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript"),this.attachListeners(w,e,a);var p=h.getConfig().getOptionsLiteral().trustedTypesPolicy;p&&(C=p.createScriptURL(C)),w.setAttribute("src",C);var r=h.getConfig().getOptionsLiteral().cspNonce;r&&w.setAttribute("nonce",r),document.getElementsByTagName("head")[0].appendChild(w)}},u}();function R(u){var h=u.getConfig().getOptionsLiteral().trustedTypesPolicy;try{var C=h?self.eval(h.createScript("","true")):new Function("true");return C.call(self),!0}catch(e){return!1}}var E=function(){function u(){this._cachedCanUseEval=null}return u.prototype._canUseEval=function(h){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=R(h)),this._cachedCanUseEval},u.prototype.load=function(h,C,e,a){if(/^node\|/.test(C)){var d=h.getConfig().getOptionsLiteral(),S=L(h.getRecorder(),d.nodeRequire||I.global.nodeRequire),b=C.split("|"),v=null;try{v=S(b[1])}catch(r){a(r);return}h.enqueueDefineAnonymousModule([],function(){return v}),e()}else{var w=h.getConfig().getOptionsLiteral().trustedTypesPolicy,p=/^((http:)|(https:)|(file:))/.test(C)&&C.substring(0,self.origin.length)!==self.origin;if(!p&&this._canUseEval(h)){fetch(C).then(function(r){if(r.status!==200)throw new Error(r.statusText);return r.text()}).then(function(r){r=r+`
//# sourceURL=`+C;var i=w?self.eval(w.createScript("",r)):new Function(r);i.call(self),e()}).then(void 0,a);return}try{w&&(C=w.createScriptURL(C)),importScripts(C),e()}catch(r){a(r)}}},u}(),o=function(){function u(h){this._env=h,this._didInitialize=!1,this._didPatchNodeRequire=!1}return u.prototype._init=function(h){this._didInitialize||(this._didInitialize=!0,this._fs=h("fs"),this._vm=h("vm"),this._path=h("path"),this._crypto=h("crypto"))},u.prototype._initNodeRequire=function(h,C){var e=C.getConfig().getOptionsLiteral().nodeCachedData;if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;var a=this,d=h("module");function S(b){var v=b.constructor,w=function(r){try{return b.require(r)}finally{}};return w.resolve=function(r,i){return v._resolveFilename(r,b,!1,i)},w.resolve.paths=function(r){return v._resolveLookupPaths(r,b)},w.main=process.mainModule,w.extensions=v._extensions,w.cache=v._cache,w}d.prototype._compile=function(b,v){var w=d.wrap(b.replace(/^#!.*/,"")),p=C.getRecorder(),r=a._getCachedDataPath(e,v),i={filename:v},s;try{var c=a._fs.readFileSync(r);s=c.slice(0,16),i.cachedData=c.slice(16),p.record(60,r)}catch(y){p.record(61,r)}var g=new a._vm.Script(w,i),l=g.runInThisContext(i),_=a._path.dirname(v),f=S(this),N=[this.exports,f,this,v,_,process,me,Buffer],A=l.apply(this.exports,N);return a._handleCachedData(g,w,r,!i.cachedData,C),a._verifyCachedData(g,w,r,s,C),A}},u.prototype.load=function(h,C,e,a){var d=this,S=h.getConfig().getOptionsLiteral(),b=L(h.getRecorder(),S.nodeRequire||I.global.nodeRequire),v=S.nodeInstrumenter||function(l){return l};this._init(b),this._initNodeRequire(b,h);var w=h.getRecorder();if(/^node\|/.test(C)){var p=C.split("|"),r=null;try{r=b(p[1])}catch(l){a(l);return}h.enqueueDefineAnonymousModule([],function(){return r}),e()}else{C=I.Utilities.fileUriToFilePath(this._env.isWindows,C);var i=this._path.normalize(C),s=this._getElectronRendererScriptPathOrUri(i),c=Boolean(S.nodeCachedData),g=c?this._getCachedDataPath(S.nodeCachedData,C):void 0;this._readSourceAndCachedData(i,g,w,function(l,_,f,N){if(l){a(l);return}var A;_.charCodeAt(0)===u._BOM?A=u._PREFIX+_.substring(1)+u._SUFFIX:A=u._PREFIX+_+u._SUFFIX,A=v(A,i);var y={filename:s,cachedData:f},D=d._createAndEvalScript(h,A,y,e,a);d._handleCachedData(D,A,g,c&&!f,h),d._verifyCachedData(D,A,g,N,h)})}},u.prototype._createAndEvalScript=function(h,C,e,a,d){var S=h.getRecorder();S.record(31,e.filename);var b=new this._vm.Script(C,e),v=b.runInThisContext(e),w=h.getGlobalAMDDefineFunc(),p=!1,r=function(){return p=!0,w.apply(null,arguments)};return r.amd=w.amd,v.call(I.global,h.getGlobalAMDRequireFunc(),r,e.filename,this._path.dirname(e.filename)),S.record(32,e.filename),p?a():d(new Error("Didn't receive define call in "+e.filename+"!")),b},u.prototype._getElectronRendererScriptPathOrUri=function(h){if(!this._env.isElectronRenderer)return h;var C=h.match(/^([a-z])\:(.*)/i);return C?"file:///"+(C[1].toUpperCase()+":"+C[2]).replace(/\\/g,"/"):"file://"+h},u.prototype._getCachedDataPath=function(h,C){var e=this._crypto.createHash("md5").update(C,"utf8").update(h.seed,"utf8").update(process.arch,"").digest("hex"),a=this._path.basename(C).replace(/\.js$/,"");return this._path.join(h.path,a+"-"+e+".code")},u.prototype._handleCachedData=function(h,C,e,a,d){var S=this;h.cachedDataRejected?this._fs.unlink(e,function(b){d.getRecorder().record(62,e),S._createAndWriteCachedData(h,C,e,d),b&&d.getConfig().onError(b)}):a&&this._createAndWriteCachedData(h,C,e,d)},u.prototype._createAndWriteCachedData=function(h,C,e,a){var d=this,S=Math.ceil(a.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),b=-1,v=0,w=void 0,p=function(){setTimeout(function(){w||(w=d._crypto.createHash("md5").update(C,"utf8").digest());var r=h.createCachedData();if(!(r.length===0||r.length===b||v>=5)){if(r.length<b){p();return}b=r.length,d._fs.writeFile(e,Buffer.concat([w,r]),function(i){i&&a.getConfig().onError(i),a.getRecorder().record(63,e),p()})}},S*Math.pow(4,v++))};p()},u.prototype._readSourceAndCachedData=function(h,C,e,a){if(!C)this._fs.readFile(h,{encoding:"utf8"},a);else{var d=void 0,S=void 0,b=void 0,v=2,w=function(p){p?a(p):--v==0&&a(void 0,d,S,b)};this._fs.readFile(h,{encoding:"utf8"},function(p,r){d=r,w(p)}),this._fs.readFile(C,function(p,r){!p&&r&&r.length>0?(b=r.slice(0,16),S=r.slice(16),e.record(60,C)):e.record(61,C),w()})}},u.prototype._verifyCachedData=function(h,C,e,a,d){var S=this;!a||h.cachedDataRejected||setTimeout(function(){var b=S._crypto.createHash("md5").update(C,"utf8").digest();a.equals(b)||(d.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+e+"' now, but a RESTART IS REQUIRED")),S._fs.unlink(e,function(v){v&&d.getConfig().onError(v)}))},Math.ceil(5e3*(1+Math.random())))},u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`,u}();function L(u,h){if(h.__$__isRecorded)return h;var C=function(a){u.record(33,a);try{return h(a)}finally{u.record(34,a)}};return C.__$__isRecorded=!0,C}I.ensureRecordedNodeRequire=L;function m(u){return new n(u)}I.createScriptLoader=m})(X||(X={}));var X;(function(I){var n=function(){function m(u){var h=u.lastIndexOf("/");h!==-1?this.fromModulePath=u.substr(0,h+1):this.fromModulePath=""}return m._normalizeModuleId=function(u){var h=u,C;for(C=/\/\.\//;C.test(h);)h=h.replace(C,"/");for(h=h.replace(/^\.\//g,""),C=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;C.test(h);)h=h.replace(C,"/");return h=h.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),h},m.prototype.resolveModule=function(u){var h=u;return I.Utilities.isAbsolutePath(h)||(I.Utilities.startsWith(h,"./")||I.Utilities.startsWith(h,"../"))&&(h=m._normalizeModuleId(this.fromModulePath+h)),h},m.ROOT=new m(""),m}();I.ModuleIdResolver=n;var M=function(){function m(u,h,C,e,a,d){this.id=u,this.strId=h,this.dependencies=C,this._callback=e,this._errorback=a,this.moduleIdResolver=d,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return m._safeInvokeFunction=function(u,h){try{return{returnedValue:u.apply(I.global,h),producedError:null}}catch(C){return{returnedValue:null,producedError:C}}},m._invokeFactory=function(u,h,C,e){return u.isBuild()&&!I.Utilities.isAnonymousModule(h)?{returnedValue:null,producedError:null}:u.shouldCatchError()?this._safeInvokeFunction(C,e):{returnedValue:C.apply(I.global,e),producedError:null}},m.prototype.complete=function(u,h,C){this._isComplete=!0;var e=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);var a=m._invokeFactory(h,this.strId,this._callback,C);e=a.producedError,u.record(22,this.strId),!e&&typeof a.returnedValue!="undefined"&&(!this.exportsPassedIn||I.Utilities.isEmpty(this.exports))&&(this.exports=a.returnedValue)}else this.exports=this._callback;if(e){var d=I.ensureError(e);d.phase="factory",d.moduleId=this.strId,this.error=d,h.onError(d)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},m.prototype.onDependencyError=function(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1},m.prototype.isComplete=function(){return this._isComplete},m}();I.Module=M;var R=function(){function m(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return m.prototype.getMaxModuleId=function(){return this._nextId},m.prototype.getModuleId=function(u){var h=this._strModuleIdToIntModuleId.get(u);return typeof h=="undefined"&&(h=this._nextId++,this._strModuleIdToIntModuleId.set(u,h),this._intModuleIdToStrModuleId[h]=u),h},m.prototype.getStrModuleId=function(u){return this._intModuleIdToStrModuleId[u]},m}(),E=function(){function m(u){this.id=u}return m.EXPORTS=new m(0),m.MODULE=new m(1),m.REQUIRE=new m(2),m}();I.RegularDependency=E;var o=function(){function m(u,h,C){this.id=u,this.pluginId=h,this.pluginParam=C}return m}();I.PluginDependency=o;var L=function(){function m(u,h,C,e,a){a===void 0&&(a=0),this._env=u,this._scriptLoader=h,this._loaderAvailableTimestamp=a,this._defineFunc=C,this._requireFunc=e,this._moduleIdProvider=new R,this._config=new I.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return m.prototype.reset=function(){return new m(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},m.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},m.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},m._findRelevantLocationInStack=function(u,h){for(var C=function(i){return i.replace(/\\/g,"/")},e=C(u),a=h.split(/\n/),d=0;d<a.length;d++){var S=a[d].match(/(.*):(\d+):(\d+)\)?$/);if(S){var b=S[1],v=S[2],w=S[3],p=Math.max(b.lastIndexOf(" ")+1,b.lastIndexOf("(")+1);if(b=b.substr(p),b=C(b),b===e){var r={line:parseInt(v,10),col:parseInt(w,10)};return r.line===1&&(r.col-="(function (require, define, __filename, __dirname) { ".length),r}}}throw new Error("Could not correlate define call site for needle "+u)},m.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var u=[],h=0,C=0,e=this._modules2.length;C<e;C++){var a=this._modules2[C];if(!!a){var d=this._buildInfoPath[a.id]||null,S=this._buildInfoDefineStack[a.id]||null,b=this._buildInfoDependencies[a.id];u[h++]={id:a.strId,path:d,defineLocation:d&&S?m._findRelevantLocationInStack(d,S):null,dependencies:b,shim:null,exports:a.exports}}}return u},m.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new I.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=I.NullLoaderEventRecorder.INSTANCE),this._recorder},m.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},m.prototype.enqueueDefineAnonymousModule=function(u,h){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");var C=null;this._config.isBuild()&&(C=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:C,dependencies:u,callback:h}},m.prototype.defineModule=function(u,h,C,e,a,d){var S=this;d===void 0&&(d=new n(u));var b=this._moduleIdProvider.getModuleId(u);if(this._modules2[b]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}var v=new M(b,u,this._normalizeDependencies(h,d),C,e,d);this._modules2[b]=v,this._config.isBuild()&&(this._buildInfoDefineStack[b]=a,this._buildInfoDependencies[b]=(v.dependencies||[]).map(function(w){return S._moduleIdProvider.getStrModuleId(w.id)})),this._resolve(v)},m.prototype._normalizeDependency=function(u,h){if(u==="exports")return E.EXPORTS;if(u==="module")return E.MODULE;if(u==="require")return E.REQUIRE;var C=u.indexOf("!");if(C>=0){var e=h.resolveModule(u.substr(0,C)),a=h.resolveModule(u.substr(C+1)),d=this._moduleIdProvider.getModuleId(e+"!"+a),S=this._moduleIdProvider.getModuleId(e);return new o(d,S,a)}return new E(this._moduleIdProvider.getModuleId(h.resolveModule(u)))},m.prototype._normalizeDependencies=function(u,h){for(var C=[],e=0,a=0,d=u.length;a<d;a++)C[e++]=this._normalizeDependency(u[a],h);return C},m.prototype._relativeRequire=function(u,h,C,e){if(typeof h=="string")return this.synchronousRequire(h,u);this.defineModule(I.Utilities.generateAnonymousModule(),h,C,e,null,u)},m.prototype.synchronousRequire=function(u,h){h===void 0&&(h=new n(u));var C=this._normalizeDependency(u,h),e=this._modules2[C.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports},m.prototype.configure=function(u,h){var C=this._config.shouldRecordStats();h?this._config=new I.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!C&&(this._recorder=null)},m.prototype.getConfig=function(){return this._config},m.prototype._onLoad=function(u){if(this._currentAnonymousDefineCall!==null){var h=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),h.dependencies,h.callback,null,h.stack)}},m.prototype._createLoadError=function(u,h){var C=this,e=this._moduleIdProvider.getStrModuleId(u),a=(this._inverseDependencies2[u]||[]).map(function(S){return C._moduleIdProvider.getStrModuleId(S)}),d=I.ensureError(h);return d.phase="loading",d.moduleId=e,d.neededBy=a,d},m.prototype._onLoadError=function(u,h){var C=this._createLoadError(u,h);this._modules2[u]||(this._modules2[u]=new M(u,this._moduleIdProvider.getStrModuleId(u),[],function(){},null,null));for(var e=[],a=0,d=this._moduleIdProvider.getMaxModuleId();a<d;a++)e[a]=!1;var S=!1,b=[];for(b.push(u),e[u]=!0;b.length>0;){var v=b.shift(),w=this._modules2[v];w&&(S=w.onDependencyError(C)||S);var p=this._inverseDependencies2[v];if(p)for(var a=0,d=p.length;a<d;a++){var r=p[a];e[r]||(b.push(r),e[r]=!0)}}S||this._config.onError(C)},m.prototype._hasDependencyPath=function(u,h){var C=this._modules2[u];if(!C)return!1;for(var e=[],a=0,d=this._moduleIdProvider.getMaxModuleId();a<d;a++)e[a]=!1;var S=[];for(S.push(C),e[u]=!0;S.length>0;){var b=S.shift(),v=b.dependencies;if(v)for(var a=0,d=v.length;a<d;a++){var w=v[a];if(w.id===h)return!0;var p=this._modules2[w.id];p&&!e[w.id]&&(e[w.id]=!0,S.push(p))}}return!1},m.prototype._findCyclePath=function(u,h,C){if(u===h||C===50)return[u];var e=this._modules2[u];if(!e)return null;var a=e.dependencies;if(a)for(var d=0,S=a.length;d<S;d++){var b=this._findCyclePath(a[d].id,h,C+1);if(b!==null)return b.push(u),b}return null},m.prototype._createRequire=function(u){var h=this,C=function(e,a,d){return h._relativeRequire(u,e,a,d)};return C.toUrl=function(e){return h._config.requireToUrl(u.resolveModule(e))},C.getStats=function(){return h.getLoaderEvents()},C.hasDependencyCycle=function(){return h._hasDependencyCycle},C.config=function(e,a){a===void 0&&(a=!1),h.configure(e,a)},C.__$__nodeRequire=I.global.nodeRequire,C},m.prototype._loadModule=function(u){var h=this;if(!(this._modules2[u]||this._knownModules2[u])){this._knownModules2[u]=!0;var C=this._moduleIdProvider.getStrModuleId(u),e=this._config.moduleIdToPaths(C),a=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(C.indexOf("/")===-1||a.test(C))&&e.push("node|"+C);var d=-1,S=function(b){if(d++,d>=e.length)h._onLoadError(u,b);else{var v=e[d],w=h.getRecorder();if(h._config.isBuild()&&v==="empty:"){h._buildInfoPath[u]=v,h.defineModule(h._moduleIdProvider.getStrModuleId(u),[],null,null,null),h._onLoad(u);return}w.record(10,v),h._scriptLoader.load(h,v,function(){h._config.isBuild()&&(h._buildInfoPath[u]=v),w.record(11,v),h._onLoad(u)},function(p){w.record(12,v),S(p)})}};S(null)}},m.prototype._loadPluginDependency=function(u,h){var C=this;if(!(this._modules2[h.id]||this._knownModules2[h.id])){this._knownModules2[h.id]=!0;var e=function(a){C.defineModule(C._moduleIdProvider.getStrModuleId(h.id),[],a,null,null)};e.error=function(a){C._config.onError(C._createLoadError(h.id,a))},u.load(h.pluginParam,this._createRequire(n.ROOT),e,this._config.getOptionsLiteral())}},m.prototype._resolve=function(u){var h=this,C=u.dependencies;if(C)for(var e=0,a=C.length;e<a;e++){var d=C[e];if(d===E.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(d===E.MODULE){u.unresolvedDependenciesCount--;continue}if(d===E.REQUIRE){u.unresolvedDependenciesCount--;continue}var S=this._modules2[d.id];if(S&&S.isComplete()){if(S.error){u.onDependencyError(S.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");var b=this._findCyclePath(d.id,u.id,0)||[];b.reverse(),b.push(d.id),console.warn(b.map(function(p){return h._moduleIdProvider.getStrModuleId(p)}).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(u.id),d instanceof o){var v=this._modules2[d.pluginId];if(v&&v.isComplete()){this._loadPluginDependency(v.exports,d);continue}var w=this._inversePluginDependencies2.get(d.pluginId);w||(w=[],this._inversePluginDependencies2.set(d.pluginId,w)),w.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)},m.prototype._onModuleComplete=function(u){var h=this,C=this.getRecorder();if(!u.isComplete()){var e=u.dependencies,a=[];if(e)for(var d=0,S=e.length;d<S;d++){var b=e[d];if(b===E.EXPORTS){a[d]=u.exports;continue}if(b===E.MODULE){a[d]={id:u.strId,config:function(){return h._config.getConfigForModule(u.strId)}};continue}if(b===E.REQUIRE){a[d]=this._createRequire(u.moduleIdResolver);continue}var v=this._modules2[b.id];if(v){a[d]=v.exports;continue}a[d]=null}u.complete(C,this._config,a);var w=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,w)for(var d=0,S=w.length;d<S;d++){var p=w[d],r=this._modules2[p];r.unresolvedDependenciesCount--,r.unresolvedDependenciesCount===0&&this._onModuleComplete(r)}var i=this._inversePluginDependencies2.get(u.id);if(i){this._inversePluginDependencies2.delete(u.id);for(var d=0,S=i.length;d<S;d++)this._loadPluginDependency(u.exports,i[d])}}},m}();I.ModuleManager=L})(X||(X={}));var $,X;(function(I){var n=new I.Environment,M=null,R=function(m,u,h){typeof m!="string"&&(h=u,u=m,m=null),(typeof u!="object"||!Array.isArray(u))&&(h=u,u=null),u||(u=["require","exports","module"]),m?M.defineModule(m,u,h,null,null):M.enqueueDefineAnonymousModule(u,h)};R.amd={jQuery:!0};var E=function(m,u){u===void 0&&(u=!1),M.configure(m,u)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){E(arguments[0]);return}if(typeof arguments[0]=="string")return M.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){M.defineModule(I.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=E,o.getConfig=function(){return M.getConfig().getOptionsLiteral()},o.reset=function(){M=M.reset()},o.getBuildInfo=function(){return M.getBuildInfo()},o.getStats=function(){return M.getLoaderEvents()},o.define=R;function L(){if(typeof I.global.require!="undefined"||typeof require!="undefined"){var m=I.global.require||require;if(typeof m=="function"&&typeof m.resolve=="function"){var u=I.ensureRecordedNodeRequire(M.getRecorder(),m);I.global.nodeRequire=u,o.nodeRequire=u,o.__$__nodeRequire=u}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?(module.exports=o,require=o):(n.isElectronRenderer||(I.global.define=R),I.global.require=o)}I.init=L,(typeof I.global.define!="function"||!I.global.define.amd)&&(M=new I.ModuleManager(n,I.createScriptLoader(n),R,o,I.Utilities.getHighPerformanceTimestamp()),typeof I.global.require!="undefined"&&typeof I.global.require!="function"&&o.config(I.global.require),$=function(){return R.apply(null,arguments)},$.amd=R.amd,typeof doNotInitLoader=="undefined"&&L())})(X||(X={})),$(j[15],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ArrayQueue=n.splice=n.insertInto=n.asArray=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.flatten=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch=n.equals=n.tail2=n.tail=void 0;function M(f,N=0){return f[f.length-(1+N)]}n.tail=M;function R(f){if(f.length===0)throw new Error("Invalid tail call");return[f.slice(0,f.length-1),f[f.length-1]]}n.tail2=R;function E(f,N,A=(y,D)=>y===D){if(f===N)return!0;if(!f||!N||f.length!==N.length)return!1;for(let y=0,D=f.length;y<D;y++)if(!A(f[y],N[y]))return!1;return!0}n.equals=E;function o(f,N,A){let y=0,D=f.length-1;for(;y<=D;){const k=(y+D)/2|0,B=A(f[k],N);if(B<0)y=k+1;else if(B>0)D=k-1;else return k}return-(y+1)}n.binarySearch=o;function L(f,N){let A=0,y=f.length;if(y===0)return 0;for(;A<y;){const D=Math.floor((A+y)/2);N(f[D])?y=D:A=D+1}return A}n.findFirstInSorted=L;function m(f,N,A){if(f=f|0,f>=N.length)throw new TypeError("invalid index");let y=N[Math.floor(N.length*Math.random())],D=[],k=[],B=[];for(let U of N){const T=A(U,y);T<0?D.push(U):T>0?k.push(U):B.push(U)}return f<D.length?m(f,D,A):f<D.length+B.length?B[0]:m(f-(D.length+B.length),k,A)}n.quickSelect=m;function u(f,N){const A=[];let y;for(const D of f.slice(0).sort(N))!y||N(y[0],D)!==0?(y=[D],A.push(y)):y.push(D);return A}n.groupBy=u;function h(f){return f.filter(N=>!!N)}n.coalesce=h;function C(f){return!Array.isArray(f)||f.length===0}n.isFalsyOrEmpty=C;function e(f){return Array.isArray(f)&&f.length>0}n.isNonEmptyArray=e;function a(f,N=A=>A){const A=new Set;return f.filter(y=>{const D=N(y);return A.has(D)?!1:(A.add(D),!0)})}n.distinct=a;function d(f,N){const A=S(f,N);if(A!==-1)return f[A]}n.findLast=d;function S(f,N){for(let A=f.length-1;A>=0;A--){const y=f[A];if(N(y))return A}return-1}n.lastIndex=S;function b(f,N){return f.length>0?f[0]:N}n.firstOrDefault=b;function v(f){return[].concat(...f)}n.flatten=v;function w(f,N){let A=typeof N=="number"?f:0;typeof N=="number"?A=f:(A=0,N=f);const y=[];if(A<=N)for(let D=A;D<N;D++)y.push(D);else for(let D=A;D>N;D--)y.push(D);return y}n.range=w;function p(f,N,A){const y=f.slice(0,N),D=f.slice(N);return y.concat(A,D)}n.arrayInsert=p;function r(f,N){const A=f.indexOf(N);A>-1&&(f.splice(A,1),f.unshift(N))}n.pushToStart=r;function i(f,N){const A=f.indexOf(N);A>-1&&(f.splice(A,1),f.push(N))}n.pushToEnd=i;function s(f){return Array.isArray(f)?f:[f]}n.asArray=s;function c(f,N,A){const y=l(f,N),D=f.length,k=A.length;f.length=D+k;for(let B=D-1;B>=y;B--)f[B+k]=f[B];for(let B=0;B<k;B++)f[B+y]=A[B]}n.insertInto=c;function g(f,N,A,y){const D=l(f,N),k=f.splice(D,A);return c(f,D,y),k}n.splice=g;function l(f,N){return N<0?Math.max(N+f.length,0):Math.min(N,f.length)}class _{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}takeWhile(N){let A=this.firstIdx;for(;A<this.items.length&&N(this.items[A]);)A++;const y=A===this.firstIdx?null:this.items.slice(this.firstIdx,A);return this.firstIdx=A,y}takeFromEndWhile(N){let A=this.lastIdx;for(;A>=0&&N(this.items[A]);)A--;const y=A===this.lastIdx?null:this.items.slice(A+1,this.lastIdx+1);return this.lastIdx=A,y}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const A=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,A}}n.ArrayQueue=_}),$(j[16],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class M{constructor(E,o,L,m){this.originalStart=E,this.originalLength=o,this.modifiedStart=L,this.modifiedLength=m}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=M}),$(j[8],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.isPromiseCanceledError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class M{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(d){setTimeout(()=>{throw d.stack?new Error(d.message+`

`+d.stack):d},0)}}emit(d){this.listeners.forEach(S=>{S(d)})}onUnexpectedError(d){this.unexpectedErrorHandler(d),this.emit(d)}onUnexpectedExternalError(d){this.unexpectedErrorHandler(d)}}n.ErrorHandler=M,n.errorHandler=new M;function R(a){m(a)||n.errorHandler.onUnexpectedError(a)}n.onUnexpectedError=R;function E(a){m(a)||n.errorHandler.onUnexpectedExternalError(a)}n.onUnexpectedExternalError=E;function o(a){if(a instanceof Error){let{name:d,message:S}=a;const b=a.stacktrace||a.stack;return{$isError:!0,name:d,message:S,stack:b}}return a}n.transformErrorForSerialization=o;const L="Canceled";function m(a){return a instanceof Error&&a.name===L&&a.message===L}n.isPromiseCanceledError=m;function u(){const a=new Error(L);return a.name=a.message,a}n.canceled=u;function h(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}n.illegalArgument=h;function C(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}n.illegalState=C;class e extends Error{constructor(d){super("NotSupported");d&&(this.message=d)}}n.NotSupportedError=e}),$(j[17],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function M(R){const E=this;let o=!1,L;return function(){return o||(o=!0,L=R.apply(E,arguments)),L}}n.once=M}),$(j[18],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var M;(function(R){function E(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=E;const o=Object.freeze([]);function L(){return o}R.empty=L;function*m(s){yield s}R.single=m;function u(s){return s||o}R.from=u;function h(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=h;function C(s){return s[Symbol.iterator]().next().value}R.first=C;function e(s,c){for(const g of s)if(c(g))return!0;return!1}R.some=e;function a(s,c){for(const g of s)if(c(g))return g}R.find=a;function*d(s,c){for(const g of s)c(g)&&(yield g)}R.filter=d;function*S(s,c){let g=0;for(const l of s)yield c(l,g++)}R.map=S;function*b(...s){for(const c of s)for(const g of c)yield g}R.concat=b;function*v(s){for(const c of s)for(const g of c)yield g}R.concatNested=v;function w(s,c,g){let l=g;for(const _ of s)l=c(l,_);return l}R.reduce=w;function*p(s,c,g=s.length){for(c<0&&(c+=s.length),g<0?g+=s.length:g>s.length&&(g=s.length);c<g;c++)yield s[c]}R.slice=p;function r(s,c=Number.POSITIVE_INFINITY){const g=[];if(c===0)return[g,s];const l=s[Symbol.iterator]();for(let _=0;_<c;_++){const f=l.next();if(f.done)return[g,R.empty()];g.push(f.value)}return[g,{[Symbol.iterator](){return l}}]}R.consume=r;function i(s,c,g=(l,_)=>l===_){const l=s[Symbol.iterator](),_=c[Symbol.iterator]();for(;;){const f=l.next(),N=_.next();if(f.done!==N.done)return!1;if(f.done)return!0;if(!g(f.value,N.value))return!1}}R.equals=i})(M=n.Iterable||(n.Iterable={}))}),$(j[19],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,d){this._keyCodeToStr[a]=d,this._strToKeyCode[d.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const R=new M,E=new M,o=new M;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const L=[],m=Object.create(null),u=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=126;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",a=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",0,e,0,e,e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_CLEAR",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]];let d=[],S=[];for(const b of a){const[v,w,p,r,i,s,c,g,l,_]=b;if(S[p]||(S[p]=!0,L[p]=r,m[r]=p,u[r.toLowerCase()]=p,w&&(n.IMMUTABLE_CODE_TO_KEY_CODE[p]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[i]=p))),!d[i]){if(d[i]=!0,!s)throw new Error(`String representation missing for key code ${i} around scan code ${r}`);R.define(i,s),E.define(i,l||s),o.define(i,_||l||s)}c&&(n.EVENT_KEY_CODE_MAP[c]=i),g&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[g]=i)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var h;(function(e){function a(p){return R.keyCodeToStr(p)}e.toString=a;function d(p){return R.strToKeyCode(p)}e.fromString=d;function S(p){return E.keyCodeToStr(p)}e.toUserSettingsUS=S;function b(p){return o.keyCodeToStr(p)}e.toUserSettingsGeneral=b;function v(p){return E.strToKeyCode(p)||o.strToKeyCode(p)}e.fromUserSettings=v;function w(p){if(p>=93&&p<=108)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return R.keyCodeToStr(p)}e.toElectronAccelerator=w})(h=n.KeyCodeUtils||(n.KeyCodeUtils={}));function C(e,a){const d=(a&65535)<<16>>>0;return(e|d)>>>0}n.KeyChord=C}),$(j[9],G([0,1,17,18]),function(I,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ImmortalReference=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.MultiDisposeError=n.markAsSingleton=n.setDisposableTracker=void 0;const E=!1;let o=null;function L(s){o=s}if(n.setDisposableTracker=L,E){const s="__is_disposable_tracked__";L(new class{trackDisposable(c){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[s]||console.log(g)},3e3)}setParent(c,g){if(c&&c!==p.None)try{c[s]=!0}catch(l){}}markAsDisposed(c){if(c&&c!==p.None)try{c[s]=!0}catch(g){}}markAsSingleton(c){}})}function m(s){return o==null||o.trackDisposable(s),s}function u(s){o==null||o.markAsDisposed(s)}function h(s,c){o==null||o.setParent(s,c)}function C(s,c){if(!!o)for(const g of s)o.setParent(g,c)}function e(s){return o==null||o.markAsSingleton(s),s}n.markAsSingleton=e;class a extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}n.MultiDisposeError=a;function d(s){return typeof s.dispose=="function"&&s.dispose.length===0}n.isDisposable=d;function S(s){if(R.Iterable.is(s)){let c=[];for(const g of s)if(g)try{g.dispose()}catch(l){c.push(l)}if(c.length===1)throw c[0];if(c.length>1)throw new a(c);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}n.dispose=S;function b(...s){const c=v(()=>S(s));return C(s,c),c}n.combinedDisposable=b;function v(s){const c=m({dispose:(0,M.once)(()=>{u(c),s()})});return c}n.toDisposable=v;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,m(this)}dispose(){this._isDisposed||(u(this),this._isDisposed=!0,this.clear())}clear(){try{S(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return h(c,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}n.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new w,m(this),h(this._store,this)}dispose(){u(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}n.Disposable=p,p.None=Object.freeze({dispose(){}});class r{constructor(){this._isDisposed=!1,m(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var g;this._isDisposed||c===this._value||((g=this._value)===null||g===void 0||g.dispose(),c&&h(c,this),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,u(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&h(c,null),c}}n.MutableDisposable=r;class i{constructor(c){this.object=c}dispose(){}}n.ImmortalReference=i}),$(j[20],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class M{constructor(o){this.element=o,this.next=M.Undefined,this.prev=M.Undefined}}M.Undefined=new M(void 0);class R{constructor(){this._first=M.Undefined,this._last=M.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===M.Undefined}clear(){let o=this._first;for(;o!==M.Undefined;){const L=o.next;o.prev=M.Undefined,o.next=M.Undefined,o=L}this._first=M.Undefined,this._last=M.Undefined,this._size=0}unshift(o){return this._insert(o,!1)}push(o){return this._insert(o,!0)}_insert(o,L){const m=new M(o);if(this._first===M.Undefined)this._first=m,this._last=m;else if(L){const h=this._last;this._last=m,m.prev=h,h.next=m}else{const h=this._first;this._first=m,m.next=h,h.prev=m}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(m))}}shift(){if(this._first!==M.Undefined){const o=this._first.element;return this._remove(this._first),o}}pop(){if(this._last!==M.Undefined){const o=this._last.element;return this._remove(this._last),o}}_remove(o){if(o.prev!==M.Undefined&&o.next!==M.Undefined){const L=o.prev;L.next=o.next,o.next.prev=L}else o.prev===M.Undefined&&o.next===M.Undefined?(this._first=M.Undefined,this._last=M.Undefined):o.next===M.Undefined?(this._last=this._last.prev,this._last.next=M.Undefined):o.prev===M.Undefined&&(this._first=this._first.next,this._first.prev=M.Undefined);this._size-=1}*[Symbol.iterator](){let o=this._first;for(;o!==M.Undefined;)yield o.element,o=o.next}}n.LinkedList=R}),$(j[2],G([0,1]),function(I,n){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isLittleEndian=n.OS=n.setTimeout0=n.locale=n.language=n.userAgent=n.isIOS=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=void 0;const R="en";let E=!1,o=!1,L=!1,m=!1,u=!1,h=!1,C=!1,e,a=R,d,S;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.process!="undefined"?b=n.globals.vscode.process:typeof process!="undefined"&&(b=process);const v=typeof((M=b==null?void 0:b.versions)===null||M===void 0?void 0:M.electron)=="string"&&b.type==="renderer";if(typeof navigator=="object"&&!v)S=navigator.userAgent,E=S.indexOf("Windows")>=0,o=S.indexOf("Macintosh")>=0,C=(S.indexOf("Macintosh")>=0||S.indexOf("iPad")>=0||S.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=S.indexOf("Linux")>=0,h=!0,e=navigator.language,a=e;else if(typeof b=="object"){E=b.platform==="win32",o=b.platform==="darwin",L=b.platform==="linux",m=L&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,e=R,a=R;const s=b.env.VSCODE_NLS_CONFIG;if(s)try{const c=JSON.parse(s),g=c.availableLanguages["*"];e=c.locale,a=g||R,d=c._translationsConfigFile}catch(c){}u=!0}else console.error("Unable to resolve platform.");let w=0;o?w=1:E?w=3:L&&(w=2),n.isWindows=E,n.isMacintosh=o,n.isLinux=L,n.isNative=u,n.isWeb=h,n.isIOS=C,n.userAgent=S,n.language=a,n.locale=e,n.setTimeout0=(()=>{if(typeof n.globals.postMessage=="function"&&!n.globals.importScripts){let s=[];n.globals.addEventListener("message",g=>{if(g.data&&g.data.vscodeScheduleAsyncWork)for(let l=0,_=s.length;l<_;l++){const f=s[l];if(f.id===g.data.vscodeScheduleAsyncWork){s.splice(l,1),f.callback();return}}});let c=0;return g=>{const l=++c;s.push({id:l,callback:g}),n.globals.postMessage({vscodeScheduleAsyncWork:l},"*")}}return s=>setTimeout(s)})(),n.OS=o||C?2:E?1:3;let p=!0,r=!1;function i(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,p=new Uint16Array(s.buffer)[0]===(2<<8)+1}return p}n.isLittleEndian=i}),$(j[21],G([0,1,2]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let R;if(typeof M.globals.vscode!="undefined"&&typeof M.globals.vscode.process!="undefined"){const E=M.globals.vscode.process;R={get platform(){return E.platform},get arch(){return E.arch},get env(){return E.env},cwd(){return E.cwd()}}}else typeof process!="undefined"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return M.isWindows?"win32":M.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=R.cwd,n.env=R.env,n.platform=R.platform}),$(j[22],G([0,1,21]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const R=65,E=97,o=90,L=122,m=46,u=47,h=92,C=58,e=63;class a extends Error{constructor(i,s,c){let g;typeof s=="string"&&s.indexOf("not ")===0?(g="must not be",s=s.replace(/^not /,"")):g="must be";const l=i.indexOf(".")!==-1?"property":"argument";let _=`The "${i}" ${l} ${g} of type ${s}`;_+=`. Received type ${typeof c}`,super(_),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,i){if(typeof r!="string")throw new a(i,"string",r)}function S(r){return r===u||r===h}function b(r){return r===u}function v(r){return r>=R&&r<=o||r>=E&&r<=L}function w(r,i,s,c){let g="",l=0,_=-1,f=0,N=0;for(let A=0;A<=r.length;++A){if(A<r.length)N=r.charCodeAt(A);else{if(c(N))break;N=u}if(c(N)){if(!(_===A-1||f===1))if(f===2){if(g.length<2||l!==2||g.charCodeAt(g.length-1)!==m||g.charCodeAt(g.length-2)!==m){if(g.length>2){const y=g.lastIndexOf(s);y===-1?(g="",l=0):(g=g.slice(0,y),l=g.length-1-g.lastIndexOf(s)),_=A,f=0;continue}else if(g.length!==0){g="",l=0,_=A,f=0;continue}}i&&(g+=g.length>0?`${s}..`:"..",l=2)}else g.length>0?g+=`${s}${r.slice(_+1,A)}`:g=r.slice(_+1,A),l=A-_-1;_=A,f=0}else N===m&&f!==-1?++f:f=-1}return g}function p(r,i){if(i===null||typeof i!="object")throw new a("pathObject","Object",i);const s=i.dir||i.root,c=i.base||`${i.name||""}${i.ext||""}`;return s?s===i.root?`${s}${c}`:`${s}${r}${c}`:c}n.win32={resolve(...r){let i="",s="",c=!1;for(let g=r.length-1;g>=-1;g--){let l;if(g>=0){if(l=r[g],d(l,"path"),l.length===0)continue}else i.length===0?l=M.cwd():(l=M.env[`=${i}`]||M.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==i.toLowerCase()&&l.charCodeAt(2)===h)&&(l=`${i}\\`));const _=l.length;let f=0,N="",A=!1;const y=l.charCodeAt(0);if(_===1)S(y)&&(f=1,A=!0);else if(S(y))if(A=!0,S(l.charCodeAt(1))){let D=2,k=D;for(;D<_&&!S(l.charCodeAt(D));)D++;if(D<_&&D!==k){const B=l.slice(k,D);for(k=D;D<_&&S(l.charCodeAt(D));)D++;if(D<_&&D!==k){for(k=D;D<_&&!S(l.charCodeAt(D));)D++;(D===_||D!==k)&&(N=`\\\\${B}\\${l.slice(k,D)}`,f=D)}}}else f=1;else v(y)&&l.charCodeAt(1)===C&&(N=l.slice(0,2),f=2,_>2&&S(l.charCodeAt(2))&&(A=!0,f=3));if(N.length>0)if(i.length>0){if(N.toLowerCase()!==i.toLowerCase())continue}else i=N;if(c){if(i.length>0)break}else if(s=`${l.slice(f)}\\${s}`,c=A,A&&i.length>0)break}return s=w(s,!c,"\\",S),c?`${i}\\${s}`:`${i}${s}`||"."},normalize(r){d(r,"path");const i=r.length;if(i===0)return".";let s=0,c,g=!1;const l=r.charCodeAt(0);if(i===1)return b(l)?"\\":r;if(S(l))if(g=!0,S(r.charCodeAt(1))){let f=2,N=f;for(;f<i&&!S(r.charCodeAt(f));)f++;if(f<i&&f!==N){const A=r.slice(N,f);for(N=f;f<i&&S(r.charCodeAt(f));)f++;if(f<i&&f!==N){for(N=f;f<i&&!S(r.charCodeAt(f));)f++;if(f===i)return`\\\\${A}\\${r.slice(N)}\\`;f!==N&&(c=`\\\\${A}\\${r.slice(N,f)}`,s=f)}}}else s=1;else v(l)&&r.charCodeAt(1)===C&&(c=r.slice(0,2),s=2,i>2&&S(r.charCodeAt(2))&&(g=!0,s=3));let _=s<i?w(r.slice(s),!g,"\\",S):"";return _.length===0&&!g&&(_="."),_.length>0&&S(r.charCodeAt(i-1))&&(_+="\\"),c===void 0?g?`\\${_}`:_:g?`${c}\\${_}`:`${c}${_}`},isAbsolute(r){d(r,"path");const i=r.length;if(i===0)return!1;const s=r.charCodeAt(0);return S(s)||i>2&&v(s)&&r.charCodeAt(1)===C&&S(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let i,s;for(let l=0;l<r.length;++l){const _=r[l];d(_,"path"),_.length>0&&(i===void 0?i=s=_:i+=`\\${_}`)}if(i===void 0)return".";let c=!0,g=0;if(typeof s=="string"&&S(s.charCodeAt(0))){++g;const l=s.length;l>1&&S(s.charCodeAt(1))&&(++g,l>2&&(S(s.charCodeAt(2))?++g:c=!1))}if(c){for(;g<i.length&&S(i.charCodeAt(g));)g++;g>=2&&(i=`\\${i.slice(g)}`)}return n.win32.normalize(i)},relative(r,i){if(d(r,"from"),d(i,"to"),r===i)return"";const s=n.win32.resolve(r),c=n.win32.resolve(i);if(s===c||(r=s.toLowerCase(),i=c.toLowerCase(),r===i))return"";let g=0;for(;g<r.length&&r.charCodeAt(g)===h;)g++;let l=r.length;for(;l-1>g&&r.charCodeAt(l-1)===h;)l--;const _=l-g;let f=0;for(;f<i.length&&i.charCodeAt(f)===h;)f++;let N=i.length;for(;N-1>f&&i.charCodeAt(N-1)===h;)N--;const A=N-f,y=_<A?_:A;let D=-1,k=0;for(;k<y;k++){const U=r.charCodeAt(g+k);if(U!==i.charCodeAt(f+k))break;U===h&&(D=k)}if(k!==y){if(D===-1)return c}else{if(A>y){if(i.charCodeAt(f+k)===h)return c.slice(f+k+1);if(k===2)return c.slice(f+k)}_>y&&(r.charCodeAt(g+k)===h?D=k:k===2&&(D=3)),D===-1&&(D=0)}let B="";for(k=g+D+1;k<=l;++k)(k===l||r.charCodeAt(k)===h)&&(B+=B.length===0?"..":"\\..");return f+=D,B.length>0?`${B}${c.slice(f,N)}`:(c.charCodeAt(f)===h&&++f,c.slice(f,N))},toNamespacedPath(r){if(typeof r!="string")return r;if(r.length===0)return"";const i=n.win32.resolve(r);if(i.length<=2)return r;if(i.charCodeAt(0)===h){if(i.charCodeAt(1)===h){const s=i.charCodeAt(2);if(s!==e&&s!==m)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(v(i.charCodeAt(0))&&i.charCodeAt(1)===C&&i.charCodeAt(2)===h)return`\\\\?\\${i}`;return r},dirname(r){d(r,"path");const i=r.length;if(i===0)return".";let s=-1,c=0;const g=r.charCodeAt(0);if(i===1)return S(g)?r:".";if(S(g)){if(s=c=1,S(r.charCodeAt(1))){let f=2,N=f;for(;f<i&&!S(r.charCodeAt(f));)f++;if(f<i&&f!==N){for(N=f;f<i&&S(r.charCodeAt(f));)f++;if(f<i&&f!==N){for(N=f;f<i&&!S(r.charCodeAt(f));)f++;if(f===i)return r;f!==N&&(s=c=f+1)}}}}else v(g)&&r.charCodeAt(1)===C&&(s=i>2&&S(r.charCodeAt(2))?3:2,c=s);let l=-1,_=!0;for(let f=i-1;f>=c;--f)if(S(r.charCodeAt(f))){if(!_){l=f;break}}else _=!1;if(l===-1){if(s===-1)return".";l=s}return r.slice(0,l)},basename(r,i){i!==void 0&&d(i,"ext"),d(r,"path");let s=0,c=-1,g=!0,l;if(r.length>=2&&v(r.charCodeAt(0))&&r.charCodeAt(1)===C&&(s=2),i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let _=i.length-1,f=-1;for(l=r.length-1;l>=s;--l){const N=r.charCodeAt(l);if(S(N)){if(!g){s=l+1;break}}else f===-1&&(g=!1,f=l+1),_>=0&&(N===i.charCodeAt(_)?--_==-1&&(c=l):(_=-1,c=f))}return s===c?c=f:c===-1&&(c=r.length),r.slice(s,c)}for(l=r.length-1;l>=s;--l)if(S(r.charCodeAt(l))){if(!g){s=l+1;break}}else c===-1&&(g=!1,c=l+1);return c===-1?"":r.slice(s,c)},extname(r){d(r,"path");let i=0,s=-1,c=0,g=-1,l=!0,_=0;r.length>=2&&r.charCodeAt(1)===C&&v(r.charCodeAt(0))&&(i=c=2);for(let f=r.length-1;f>=i;--f){const N=r.charCodeAt(f);if(S(N)){if(!l){c=f+1;break}continue}g===-1&&(l=!1,g=f+1),N===m?s===-1?s=f:_!==1&&(_=1):s!==-1&&(_=-1)}return s===-1||g===-1||_===0||_===1&&s===g-1&&s===c+1?"":r.slice(s,g)},format:p.bind(null,"\\"),parse(r){d(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const s=r.length;let c=0,g=r.charCodeAt(0);if(s===1)return S(g)?(i.root=i.dir=r,i):(i.base=i.name=r,i);if(S(g)){if(c=1,S(r.charCodeAt(1))){let D=2,k=D;for(;D<s&&!S(r.charCodeAt(D));)D++;if(D<s&&D!==k){for(k=D;D<s&&S(r.charCodeAt(D));)D++;if(D<s&&D!==k){for(k=D;D<s&&!S(r.charCodeAt(D));)D++;D===s?c=D:D!==k&&(c=D+1)}}}}else if(v(g)&&r.charCodeAt(1)===C){if(s<=2)return i.root=i.dir=r,i;if(c=2,S(r.charCodeAt(2))){if(s===3)return i.root=i.dir=r,i;c=3}}c>0&&(i.root=r.slice(0,c));let l=-1,_=c,f=-1,N=!0,A=r.length-1,y=0;for(;A>=c;--A){if(g=r.charCodeAt(A),S(g)){if(!N){_=A+1;break}continue}f===-1&&(N=!1,f=A+1),g===m?l===-1?l=A:y!==1&&(y=1):l!==-1&&(y=-1)}return f!==-1&&(l===-1||y===0||y===1&&l===f-1&&l===_+1?i.base=i.name=r.slice(_,f):(i.name=r.slice(_,l),i.base=r.slice(_,f),i.ext=r.slice(l,f))),_>0&&_!==c?i.dir=r.slice(0,_-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null},n.posix={resolve(...r){let i="",s=!1;for(let c=r.length-1;c>=-1&&!s;c--){const g=c>=0?r[c]:M.cwd();d(g,"path"),g.length!==0&&(i=`${g}/${i}`,s=g.charCodeAt(0)===u)}return i=w(i,!s,"/",b),s?`/${i}`:i.length>0?i:"."},normalize(r){if(d(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===u,s=r.charCodeAt(r.length-1)===u;return r=w(r,!i,"/",b),r.length===0?i?"/":s?"./":".":(s&&(r+="/"),i?`/${r}`:r)},isAbsolute(r){return d(r,"path"),r.length>0&&r.charCodeAt(0)===u},join(...r){if(r.length===0)return".";let i;for(let s=0;s<r.length;++s){const c=r[s];d(c,"path"),c.length>0&&(i===void 0?i=c:i+=`/${c}`)}return i===void 0?".":n.posix.normalize(i)},relative(r,i){if(d(r,"from"),d(i,"to"),r===i||(r=n.posix.resolve(r),i=n.posix.resolve(i),r===i))return"";const s=1,c=r.length,g=c-s,l=1,_=i.length-l,f=g<_?g:_;let N=-1,A=0;for(;A<f;A++){const D=r.charCodeAt(s+A);if(D!==i.charCodeAt(l+A))break;D===u&&(N=A)}if(A===f)if(_>f){if(i.charCodeAt(l+A)===u)return i.slice(l+A+1);if(A===0)return i.slice(l+A)}else g>f&&(r.charCodeAt(s+A)===u?N=A:A===0&&(N=0));let y="";for(A=s+N+1;A<=c;++A)(A===c||r.charCodeAt(A)===u)&&(y+=y.length===0?"..":"/..");return`${y}${i.slice(l+N)}`},toNamespacedPath(r){return r},dirname(r){if(d(r,"path"),r.length===0)return".";const i=r.charCodeAt(0)===u;let s=-1,c=!0;for(let g=r.length-1;g>=1;--g)if(r.charCodeAt(g)===u){if(!c){s=g;break}}else c=!1;return s===-1?i?"/":".":i&&s===1?"//":r.slice(0,s)},basename(r,i){i!==void 0&&d(i,"ext"),d(r,"path");let s=0,c=-1,g=!0,l;if(i!==void 0&&i.length>0&&i.length<=r.length){if(i===r)return"";let _=i.length-1,f=-1;for(l=r.length-1;l>=0;--l){const N=r.charCodeAt(l);if(N===u){if(!g){s=l+1;break}}else f===-1&&(g=!1,f=l+1),_>=0&&(N===i.charCodeAt(_)?--_==-1&&(c=l):(_=-1,c=f))}return s===c?c=f:c===-1&&(c=r.length),r.slice(s,c)}for(l=r.length-1;l>=0;--l)if(r.charCodeAt(l)===u){if(!g){s=l+1;break}}else c===-1&&(g=!1,c=l+1);return c===-1?"":r.slice(s,c)},extname(r){d(r,"path");let i=-1,s=0,c=-1,g=!0,l=0;for(let _=r.length-1;_>=0;--_){const f=r.charCodeAt(_);if(f===u){if(!g){s=_+1;break}continue}c===-1&&(g=!1,c=_+1),f===m?i===-1?i=_:l!==1&&(l=1):i!==-1&&(l=-1)}return i===-1||c===-1||l===0||l===1&&i===c-1&&i===s+1?"":r.slice(i,c)},format:p.bind(null,"/"),parse(r){d(r,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return i;const s=r.charCodeAt(0)===u;let c;s?(i.root="/",c=1):c=0;let g=-1,l=0,_=-1,f=!0,N=r.length-1,A=0;for(;N>=c;--N){const y=r.charCodeAt(N);if(y===u){if(!f){l=N+1;break}continue}_===-1&&(f=!1,_=N+1),y===m?g===-1?g=N:A!==1&&(A=1):g!==-1&&(A=-1)}if(_!==-1){const y=l===0&&s?1:l;g===-1||A===0||A===1&&g===_-1&&g===l+1?i.base=i.name=r.slice(y,_):(i.name=r.slice(y,g),i.base=r.slice(y,_),i.ext=r.slice(g,_))}return l>0?i.dir=r.slice(0,l-1):s&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=M.platform==="win32"?n.win32.normalize:n.posix.normalize,n.resolve=M.platform==="win32"?n.win32.resolve:n.posix.resolve,n.relative=M.platform==="win32"?n.win32.relative:n.posix.relative,n.dirname=M.platform==="win32"?n.win32.dirname:n.posix.dirname,n.basename=M.platform==="win32"?n.win32.basename:n.posix.basename,n.extname=M.platform==="win32"?n.win32.extname:n.posix.extname,n.sep=M.platform==="win32"?n.win32.sep:n.posix.sep}),$(j[10],G([0,1,2]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const R=M.globals.performance&&typeof M.globals.performance.now=="function";class E{constructor(L){this._highResolution=R&&L,this._startTime=this._now(),this._stopTime=-1}static create(L=!0){return new E(L)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?M.globals.performance.now():Date.now()}}n.StopWatch=E}),$(j[6],G([0,1,8,9,20,10]),function(I,n,M,R,E,o){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.DebounceEmitter=n.PauseableEmitter=n.Emitter=n.Event=void 0;var L;(function(b){b.None=()=>R.Disposable.None;function v(U){return(T,H=null,W)=>{let t=!1,V;return V=U(Y=>{if(!t)return V?V.dispose():t=!0,T.call(H,Y)},null,W),t&&V.dispose(),V}}b.once=v;function w(U,T){return g((H,W=null,t)=>U(V=>H.call(W,T(V)),null,t))}b.map=w;function p(U,T){return g((H,W=null,t)=>U(V=>{T(V),H.call(W,V)},null,t))}b.forEach=p;function r(U,T){return g((H,W=null,t)=>U(V=>T(V)&&H.call(W,V),null,t))}b.filter=r;function i(U){return U}b.signal=i;function s(...U){return(T,H=null,W)=>(0,R.combinedDisposable)(...U.map(t=>t(V=>T.call(H,V),null,W)))}b.any=s;function c(U,T,H){let W=H;return w(U,t=>(W=T(W,t),W))}b.reduce=c;function g(U){let T;const H=new C({onFirstListenerAdd(){T=U(H.fire,H)},onLastListenerRemove(){T.dispose()}});return H.event}function l(U,T,H=100,W=!1,t){let V,Y,Z,se=0;const le=new C({leakWarningThreshold:t,onFirstListenerAdd(){V=U(oe=>{se++,Y=T(Y,oe),W&&!Z&&(le.fire(Y),Y=void 0),clearTimeout(Z),Z=setTimeout(()=>{const ae=Y;Y=void 0,Z=void 0,(!W||se>1)&&le.fire(ae),se=0},H)})},onLastListenerRemove(){V.dispose()}});return le.event}b.debounce=l;function _(U,T=(H,W)=>H===W){let H=!0,W;return r(U,t=>{const V=H||!T(t,W);return H=!1,W=t,V})}b.latch=_;function f(U,T){return[b.filter(U,T),b.filter(U,H=>!T(H))]}b.split=f;function N(U,T=!1,H=[]){let W=H.slice(),t=U(Z=>{W?W.push(Z):Y.fire(Z)});const V=()=>{W&&W.forEach(Z=>Y.fire(Z)),W=null},Y=new C({onFirstListenerAdd(){t||(t=U(Z=>Y.fire(Z)))},onFirstListenerDidAdd(){W&&(T?setTimeout(V):V())},onLastListenerRemove(){t&&t.dispose(),t=null}});return Y.event}b.buffer=N;class A{constructor(T){this.event=T}map(T){return new A(w(this.event,T))}forEach(T){return new A(p(this.event,T))}filter(T){return new A(r(this.event,T))}reduce(T,H){return new A(c(this.event,T,H))}latch(){return new A(_(this.event))}debounce(T,H=100,W=!1,t){return new A(l(this.event,T,H,W,t))}on(T,H,W){return this.event(T,H,W)}once(T,H,W){return v(this.event)(T,H,W)}}function y(U){return new A(U)}b.chain=y;function D(U,T,H=W=>W){const W=(...Z)=>Y.fire(H(...Z)),t=()=>U.on(T,W),V=()=>U.removeListener(T,W),Y=new C({onFirstListenerAdd:t,onLastListenerRemove:V});return Y.event}b.fromNodeEventEmitter=D;function k(U,T,H=W=>W){const W=(...Z)=>Y.fire(H(...Z)),t=()=>U.addEventListener(T,W),V=()=>U.removeEventListener(T,W),Y=new C({onFirstListenerAdd:t,onLastListenerRemove:V});return Y.event}b.fromDOMEventEmitter=k;function B(U){return new Promise(T=>v(U)(T))}b.toPromise=B})(L=n.Event||(n.Event={}));class m{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${m._idPool++}`}start(v){this._stopWatch=new o.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let u=-1;class h{constructor(v,w=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=w,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let w=u;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||v<w)return;this._stacks||(this._stacks=new Map);const p=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(p)||0;if(this._stacks.set(p,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let i,s=0;for(const[c,g]of this._stacks)(!i||s<g)&&(i=c,s=g);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${s}):`),console.warn(i)}return()=>{const i=this._stacks.get(p)||0;this._stacks.set(p,i-1)}}}class C{constructor(v){var w;this._disposed=!1,this._options=v,this._leakageMon=u>0?new h(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((w=this._options)===null||w===void 0?void 0:w._profName)?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(v,w,p)=>{var r;this._listeners||(this._listeners=new E.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const s=this._listeners.push(w?[v,w]:v);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,w);const c=(r=this._leakageMon)===null||r===void 0?void 0:r.check(this._listeners.size),g=(0,R.toDisposable)(()=>{c&&c(),this._disposed||(s(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return p instanceof R.DisposableStore?p.add(g):Array.isArray(p)&&p.push(g),g}),this._event}fire(v){var w,p;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,v]);for((w=this._perfMon)===null||w===void 0||w.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,i]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,i):r[0].call(r[1],i)}catch(s){(0,M.onUnexpectedError)(s)}}(p=this._perfMon)===null||p===void 0||p.stop()}}dispose(){var v,w,p,r,i;this._disposed||(this._disposed=!0,(v=this._listeners)===null||v===void 0||v.clear(),(w=this._deliveryQueue)===null||w===void 0||w.clear(),(r=(p=this._options)===null||p===void 0?void 0:p.onLastListenerRemove)===null||r===void 0||r.call(p),(i=this._leakageMon)===null||i===void 0||i.dispose())}}n.Emitter=C;class e extends C{constructor(v){super(v);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=v==null?void 0:v.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}n.PauseableEmitter=e;class a extends e{constructor(v){var w;super(v);this._delay=(w=v.delay)!==null&&w!==void 0?w:100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}n.DebounceEmitter=a;class d{constructor(){this.buffers=[]}wrapEvent(v){return(w,p,r)=>v(i=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>w.call(p,i)):w.call(p,i)},void 0,r)}bufferEvents(v){const w=[];this.buffers.push(w);const p=v();return this.buffers.pop(),w.forEach(r=>r()),p}}n.EventBufferer=d;class S{constructor(){this.listening=!1,this.inputEvent=L.None,this.inputEventListener=R.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=S}),$(j[23],G([0,1,6]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const R=Object.freeze(function(m,u){const h=setTimeout(m.bind(u),0);return{dispose(){clearTimeout(h)}}});var E;(function(m){function u(h){return h===m.None||h===m.Cancelled||h instanceof o?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}m.isCancellationToken=u,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:M.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(E=n.CancellationToken||(n.CancellationToken={}));class o{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new M.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(u){this._token=void 0,this._parentListener=void 0,this._parentListener=u&&u.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=E.Cancelled}dispose(u=!1){u&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=E.None}}n.CancellationTokenSource=L}),$(j[3],G([0,1,2]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.breakBetweenGraphemeBreakType=n.getGraphemeBreakType=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsEmoji=n.containsRTL=n.prevCharLength=n.nextCharLength=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function R(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=R;const E=/{(\d+)}/g;function o(P,...F){return F.length===0?P:P.replace(E,function(O,q){const z=parseInt(q,10);return isNaN(z)||z<0||z>=F.length?O:F[z]})}n.format=o;function L(P){return P.replace(/[<>&]/g,function(F){switch(F){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return F}})}n.escape=L;function m(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=m;function u(P,F=" "){const O=h(P,F);return C(O,F)}n.trim=u;function h(P,F){if(!P||!F)return P;const O=F.length;if(O===0||P.length===0)return P;let q=0;for(;P.indexOf(F,q)===q;)q=q+O;return P.substring(q)}n.ltrim=h;function C(P,F){if(!P||!F)return P;const O=F.length,q=P.length;if(O===0||q===0)return P;let z=q,Q=-1;for(;Q=P.lastIndexOf(F,z-1),!(Q===-1||Q+O!==z);){if(Q===0)return"";z=Q}return P.substring(0,z)}n.rtrim=C;function e(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=e;function a(P){return P.replace(/\*/g,"")}n.stripWildcards=a;function d(P,F,O={}){if(!P)throw new Error("Cannot create regex from empty string");F||(P=m(P)),O.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let q="";return O.global&&(q+="g"),O.matchCase||(q+="i"),O.multiline&&(q+="m"),O.unicode&&(q+="u"),new RegExp(P,q)}n.createRegExp=d;function S(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=S;function b(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=b;function v(P){return P.split(/\r\n|\r|\n/)}n.splitLines=v;function w(P){for(let F=0,O=P.length;F<O;F++){const q=P.charCodeAt(F);if(q!==32&&q!==9)return F}return-1}n.firstNonWhitespaceIndex=w;function p(P,F=0,O=P.length){for(let q=F;q<O;q++){const z=P.charCodeAt(q);if(z!==32&&z!==9)return P.substring(F,q)}return P.substring(F,O)}n.getLeadingWhitespace=p;function r(P,F=P.length-1){for(let O=F;O>=0;O--){const q=P.charCodeAt(O);if(q!==32&&q!==9)return O}return-1}n.lastNonWhitespaceIndex=r;function i(P,F){return P<F?-1:P>F?1:0}n.compare=i;function s(P,F,O=0,q=P.length,z=0,Q=F.length){for(;O<q&&z<Q;O++,z++){let x=P.charCodeAt(O),ne=F.charCodeAt(z);if(x<ne)return-1;if(x>ne)return 1}const J=q-O,K=Q-z;return J<K?-1:J>K?1:0}n.compareSubstring=s;function c(P,F){return g(P,F,0,P.length,0,F.length)}n.compareIgnoreCase=c;function g(P,F,O=0,q=P.length,z=0,Q=F.length){for(;O<q&&z<Q;O++,z++){let x=P.charCodeAt(O),ne=F.charCodeAt(z);if(x===ne)continue;if(x>=128||ne>=128)return s(P.toLowerCase(),F.toLowerCase(),O,q,z,Q);l(x)&&(x-=32),l(ne)&&(ne-=32);const de=x-ne;if(de!==0)return de}const J=q-O,K=Q-z;return J<K?-1:J>K?1:0}n.compareSubstringIgnoreCase=g;function l(P){return P>=97&&P<=122}n.isLowerAsciiLetter=l;function _(P){return P>=65&&P<=90}n.isUpperAsciiLetter=_;function f(P,F){return P.length===F.length&&g(P,F)===0}n.equalsIgnoreCase=f;function N(P,F){const O=F.length;return F.length>P.length?!1:g(P,F,0,O)===0}n.startsWithIgnoreCase=N;function A(P,F){let O,q=Math.min(P.length,F.length);for(O=0;O<q;O++)if(P.charCodeAt(O)!==F.charCodeAt(O))return O;return q}n.commonPrefixLength=A;function y(P,F){let O,q=Math.min(P.length,F.length);const z=P.length-1,Q=F.length-1;for(O=0;O<q;O++)if(P.charCodeAt(z-O)!==F.charCodeAt(Q-O))return O;return q}n.commonSuffixLength=y;function D(P){return 55296<=P&&P<=56319}n.isHighSurrogate=D;function k(P){return 56320<=P&&P<=57343}n.isLowSurrogate=k;function B(P,F){return(P-55296<<10)+(F-56320)+65536}n.computeCodePoint=B;function U(P,F,O){const q=P.charCodeAt(O);if(D(q)&&O+1<F){const z=P.charCodeAt(O+1);if(k(z))return B(q,z)}return q}n.getNextCodePoint=U;function T(P,F){const O=P.charCodeAt(F-1);if(k(O)&&F>1){const q=P.charCodeAt(F-2);if(D(q))return B(q,O)}return O}function H(P,F){const O=ee.getInstance(),q=F,z=P.length,Q=U(P,z,F);F+=Q>=65536?2:1;let J=O.getGraphemeBreakType(Q);for(;F<z;){const K=U(P,z,F),x=O.getGraphemeBreakType(K);if(ce(J,x))break;F+=K>=65536?2:1,J=x}return F-q}n.nextCharLength=H;function W(P,F){const O=ee.getInstance(),q=F,z=T(P,F);F-=z>=65536?2:1;let Q=O.getGraphemeBreakType(z);for(;F>0;){const J=T(P,F),K=O.getGraphemeBreakType(J);if(ce(K,Q))break;F-=J>=65536?2:1,Q=K}return q-F}n.prevCharLength=W;const t=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function V(P){return t.test(P)}n.containsRTL=V;const Y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function Z(P){return Y.test(P)}n.containsEmoji=Z;const se=/^[\t\n\r\x20-\x7E]*$/;function le(P){return se.test(P)}n.isBasicASCII=le,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=oe;function ae(P){for(let F=0,O=P.length;F<O;F++)if(fe(P.charCodeAt(F)))return!0;return!1}n.containsFullWidthCharacter=ae;function fe(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=fe;function he(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=he,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function _e(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=_e;function ve(P,F=!1){return P?(F&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=ve;function Ce(P){const F=90-65+1;return P=P%(2*F),P<F?String.fromCharCode(97+P):String.fromCharCode(65+P-F)}n.singleLetterHash=Ce;function Le(P){return ee.getInstance().getGraphemeBreakType(P)}n.getGraphemeBreakType=Le;function ce(P,F){return P===0?F!==5&&F!==7:P===2&&F===3?!1:P===4||P===2||P===3||F===4||F===2||F===3?!0:!(P===8&&(F===8||F===9||F===11||F===12)||(P===11||P===9)&&(F===9||F===10)||(P===12||P===10)&&F===10||F===5||F===13||F===7||P===1||P===13&&F===14||P===6&&F===6)}n.breakBetweenGraphemeBreakType=ce;class ee{constructor(){this._data=Se()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(F){if(F<32)return F===10?3:F===13?2:4;if(F<127)return 0;const O=this._data,q=O.length/3;let z=1;for(;z<=q;)if(F<O[3*z])z=2*z;else if(F>O[3*z+1])z=2*z+1;else return O[3*z+2];return 0}}ee._INSTANCE=null;function Se(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(P,F){if(P===0)return 0;const O=Ne(P,F);if(O!==void 0)return O;const q=T(F,P);return P-=ue(q),P}n.getLeftDeleteOffset=be;function Ne(P,F){let O=T(F,P);for(P-=ue(O);we(O)||O===65039||O===8419;){if(P===0)return;O=T(F,P),P-=ue(O)}if(!!he(O)){if(P>=0){const q=T(F,P);q===8205&&(P-=ue(q))}return P}}function ue(P){return P>=65536?2:1}function we(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class te{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!te.map){let q=function(J){const K=new Map;for(let x=0;x<J.length;x+=2)K.set(J[x],J[x+1]);return K};const F=te.getData();let O=M.locale;(!O||!(O in F))&&(O=M.language),(!O||!(O in F))&&(O="_default");const z=q(F._common),Q=q(F[O]);for(const[J,K]of Q)z.set(J,K);te.map=z}return te.map}static isAmbiguous(F){return te.getConfusablesForCurrentLocale().has(F)}static getPrimaryConfusable(F){return te.getConfusablesForCurrentLocale().get(F)}static getPrimaryConfusableCodePoints(){return new Set(te.getConfusablesForCurrentLocale().keys())}}n.AmbiguousCharacters=te;class re{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(re.getRawData())),this._data}static isInvisibleCharacter(F){return re.getData().has(F)}static get codePoints(){return re.getData()}}n.InvisibleCharacters=re,re._data=void 0}),$(j[24],G([0,1,3]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function R(b){return E(b,0)}n.hash=R;function E(b,v){switch(typeof b){case"object":return b===null?o(349,v):Array.isArray(b)?u(b,v):h(b,v);case"string":return m(b,v);case"boolean":return L(b,v);case"number":return o(b,v);case"undefined":return o(937,v);default:return o(617,v)}}n.doHash=E;function o(b,v){return(v<<5)-v+b|0}n.numberHash=o;function L(b,v){return o(b?433:863,v)}function m(b,v){v=o(149417,v);for(let w=0,p=b.length;w<p;w++)v=o(b.charCodeAt(w),v);return v}n.stringHash=m;function u(b,v){return v=o(104579,v),b.reduce((w,p)=>E(p,w),v)}function h(b,v){return v=o(181387,v),Object.keys(b).sort().reduce((w,p)=>(w=m(p,w),E(b[p],w)),v)}function C(b,v,w=32){const p=w-v,r=~((1<<p)-1);return(b<<v|(r&b)>>>p)>>>0}function e(b,v=0,w=b.byteLength,p=0){for(let r=0;r<w;r++)b[v+r]=p}function a(b,v,w="0"){for(;b.length<v;)b=w+b;return b}function d(b,v=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(w=>w.toString(16).padStart(2,"0")).join(""):a((b>>>0).toString(16),v/4)}n.toHexString=d;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const w=v.length;if(w===0)return;const p=this._buff;let r=this._buffLen,i=this._leftoverHighSurrogate,s,c;for(i!==0?(s=i,c=-1,i=0):(s=v.charCodeAt(0),c=0);;){let g=s;if(M.isHighSurrogate(s))if(c+1<w){const l=v.charCodeAt(c+1);M.isLowSurrogate(l)?(c++,g=M.computeCodePoint(s,l)):g=65533}else{i=s;break}else M.isLowSurrogate(s)&&(g=65533);if(r=this._push(p,r,g),c++,c<w)s=v.charCodeAt(c);else break}this._buffLen=r,this._leftoverHighSurrogate=i}_push(v,w,p){return p<128?v[w++]=p:p<2048?(v[w++]=192|(p&1984)>>>6,v[w++]=128|(p&63)>>>0):p<65536?(v[w++]=224|(p&61440)>>>12,v[w++]=128|(p&4032)>>>6,v[w++]=128|(p&63)>>>0):(v[w++]=240|(p&1835008)>>>18,v[w++]=128|(p&258048)>>>12,v[w++]=128|(p&4032)>>>6,v[w++]=128|(p&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=S._bigBlock32,w=this._buffDV;for(let f=0;f<64;f+=4)v.setUint32(f,w.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)v.setUint32(f,C(v.getUint32(f-12,!1)^v.getUint32(f-32,!1)^v.getUint32(f-56,!1)^v.getUint32(f-64,!1),1),!1);let p=this._h0,r=this._h1,i=this._h2,s=this._h3,c=this._h4,g,l,_;for(let f=0;f<80;f++)f<20?(g=r&i|~r&s,l=1518500249):f<40?(g=r^i^s,l=1859775393):f<60?(g=r&i|r&s|i&s,l=2400959708):(g=r^i^s,l=3395469782),_=C(p,5)+g+c+l+v.getUint32(f*4,!1)&4294967295,c=s,s=i,i=C(r,30),r=p,p=_;this._h0=this._h0+p&4294967295,this._h1=this._h1+r&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+c&4294967295}}n.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),$(j[11],G([0,1,16,24]),function(I,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.MyArray=n.Debug=n.stringDiff=n.StringDiffSequence=void 0;class E{constructor(e){this.source=e}getElements(){const e=this.source,a=new Int32Array(e.length);for(let d=0,S=e.length;d<S;d++)a[d]=e.charCodeAt(d);return a}}n.StringDiffSequence=E;function o(C,e,a){return new h(new E(C),new E(e)).ComputeDiff(a).changes}n.stringDiff=o;class L{static Assert(e,a){if(!e)throw new Error(a)}}n.Debug=L;class m{static Copy(e,a,d,S,b){for(let v=0;v<b;v++)d[S+v]=e[a+v]}static Copy2(e,a,d,S,b){for(let v=0;v<b;v++)d[S+v]=e[a+v]}}n.MyArray=m;class u{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new M.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,a){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,a),this.m_originalCount++}AddModifiedElement(e,a){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,a),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class h{constructor(e,a,d=null){this.ContinueProcessingPredicate=d,this._originalSequence=e,this._modifiedSequence=a;const[S,b,v]=h._getElements(e),[w,p,r]=h._getElements(a);this._hasStrings=v&&r,this._originalStringElements=S,this._originalElementsOrHash=b,this._modifiedStringElements=w,this._modifiedElementsOrHash=p,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const a=e.getElements();if(h._isStringArray(a)){const d=new Int32Array(a.length);for(let S=0,b=a.length;S<b;S++)d[S]=(0,R.stringHash)(a[S],0);return[a,d,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}ElementsAreEqual(e,a){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[a]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[a]:!0}ElementsAreStrictEqual(e,a){if(!this.ElementsAreEqual(e,a))return!1;const d=h._getStrictElement(this._originalSequence,e),S=h._getStrictElement(this._modifiedSequence,a);return d===S}static _getStrictElement(e,a){return typeof e.getStrictElement=="function"?e.getStrictElement(a):null}OriginalElementsAreEqual(e,a){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[a]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[a]:!0}ModifiedElementsAreEqual(e,a){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[a]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[a]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,a,d,S,b){const v=[!1];let w=this.ComputeDiffRecursive(e,a,d,S,v);return b&&(w=this.PrettifyChanges(w)),{quitEarly:v[0],changes:w}}ComputeDiffRecursive(e,a,d,S,b){for(b[0]=!1;e<=a&&d<=S&&this.ElementsAreEqual(e,d);)e++,d++;for(;a>=e&&S>=d&&this.ElementsAreEqual(a,S);)a--,S--;if(e>a||d>S){let s;return d<=S?(L.Assert(e===a+1,"originalStart should only be one more than originalEnd"),s=[new M.DiffChange(e,0,d,S-d+1)]):e<=a?(L.Assert(d===S+1,"modifiedStart should only be one more than modifiedEnd"),s=[new M.DiffChange(e,a-e+1,d,0)]):(L.Assert(e===a+1,"originalStart should only be one more than originalEnd"),L.Assert(d===S+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const v=[0],w=[0],p=this.ComputeRecursionPoint(e,a,d,S,v,w,b),r=v[0],i=w[0];if(p!==null)return p;if(!b[0]){const s=this.ComputeDiffRecursive(e,r,d,i,b);let c=[];return b[0]?c=[new M.DiffChange(r+1,a-(r+1)+1,i+1,S-(i+1)+1)]:c=this.ComputeDiffRecursive(r+1,a,i+1,S,b),this.ConcatenateChanges(s,c)}return[new M.DiffChange(e,a-e+1,d,S-d+1)]}WALKTRACE(e,a,d,S,b,v,w,p,r,i,s,c,g,l,_,f,N,A){let y=null,D=null,k=new u,B=a,U=d,T=g[0]-f[0]-S,H=-1073741824,W=this.m_forwardHistory.length-1;do{const t=T+e;t===B||t<U&&r[t-1]<r[t+1]?(s=r[t+1],l=s-T-S,s<H&&k.MarkNextChange(),H=s,k.AddModifiedElement(s+1,l),T=t+1-e):(s=r[t-1]+1,l=s-T-S,s<H&&k.MarkNextChange(),H=s-1,k.AddOriginalElement(s,l+1),T=t-1-e),W>=0&&(r=this.m_forwardHistory[W],e=r[0],B=1,U=r.length-1)}while(--W>=-1);if(y=k.getReverseChanges(),A[0]){let t=g[0]+1,V=f[0]+1;if(y!==null&&y.length>0){const Y=y[y.length-1];t=Math.max(t,Y.getOriginalEnd()),V=Math.max(V,Y.getModifiedEnd())}D=[new M.DiffChange(t,c-t+1,V,_-V+1)]}else{k=new u,B=v,U=w,T=g[0]-f[0]-p,H=1073741824,W=N?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const t=T+b;t===B||t<U&&i[t-1]>=i[t+1]?(s=i[t+1]-1,l=s-T-p,s>H&&k.MarkNextChange(),H=s+1,k.AddOriginalElement(s+1,l+1),T=t+1-b):(s=i[t-1],l=s-T-p,s>H&&k.MarkNextChange(),H=s,k.AddModifiedElement(s+1,l+1),T=t-1-b),W>=0&&(i=this.m_reverseHistory[W],b=i[0],B=1,U=i.length-1)}while(--W>=-1);D=k.getChanges()}return this.ConcatenateChanges(y,D)}ComputeRecursionPoint(e,a,d,S,b,v,w){let p=0,r=0,i=0,s=0,c=0,g=0;e--,d--,b[0]=0,v[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const l=a-e+(S-d),_=l+1,f=new Int32Array(_),N=new Int32Array(_),A=S-d,y=a-e,D=e-d,k=a-S,U=(y-A)%2==0;f[A]=e,N[y]=a,w[0]=!1;for(let T=1;T<=l/2+1;T++){let H=0,W=0;i=this.ClipDiagonalBound(A-T,T,A,_),s=this.ClipDiagonalBound(A+T,T,A,_);for(let V=i;V<=s;V+=2){V===i||V<s&&f[V-1]<f[V+1]?p=f[V+1]:p=f[V-1]+1,r=p-(V-A)-D;const Y=p;for(;p<a&&r<S&&this.ElementsAreEqual(p+1,r+1);)p++,r++;if(f[V]=p,p+r>H+W&&(H=p,W=r),!U&&Math.abs(V-y)<=T-1&&p>=N[V])return b[0]=p,v[0]=r,Y<=N[V]&&1447>0&&T<=1447+1?this.WALKTRACE(A,i,s,D,y,c,g,k,f,N,p,a,b,r,S,v,U,w):null}const t=(H-e+(W-d)-T)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,t))return w[0]=!0,b[0]=H,v[0]=W,t>0&&1447>0&&T<=1447+1?this.WALKTRACE(A,i,s,D,y,c,g,k,f,N,p,a,b,r,S,v,U,w):(e++,d++,[new M.DiffChange(e,a-e+1,d,S-d+1)]);c=this.ClipDiagonalBound(y-T,T,y,_),g=this.ClipDiagonalBound(y+T,T,y,_);for(let V=c;V<=g;V+=2){V===c||V<g&&N[V-1]>=N[V+1]?p=N[V+1]-1:p=N[V-1],r=p-(V-y)-k;const Y=p;for(;p>e&&r>d&&this.ElementsAreEqual(p,r);)p--,r--;if(N[V]=p,U&&Math.abs(V-A)<=T&&p<=f[V])return b[0]=p,v[0]=r,Y>=f[V]&&1447>0&&T<=1447+1?this.WALKTRACE(A,i,s,D,y,c,g,k,f,N,p,a,b,r,S,v,U,w):null}if(T<=1447){let V=new Int32Array(s-i+2);V[0]=A-i+1,m.Copy2(f,i,V,1,s-i+1),this.m_forwardHistory.push(V),V=new Int32Array(g-c+2),V[0]=y-c+1,m.Copy2(N,c,V,1,g-c+1),this.m_reverseHistory.push(V)}}return this.WALKTRACE(A,i,s,D,y,c,g,k,f,N,p,a,b,r,S,v,U,w)}PrettifyChanges(e){for(let a=0;a<e.length;a++){const d=e[a],S=a<e.length-1?e[a+1].originalStart:this._originalElementsOrHash.length,b=a<e.length-1?e[a+1].modifiedStart:this._modifiedElementsOrHash.length,v=d.originalLength>0,w=d.modifiedLength>0;for(;d.originalStart+d.originalLength<S&&d.modifiedStart+d.modifiedLength<b&&(!v||this.OriginalElementsAreEqual(d.originalStart,d.originalStart+d.originalLength))&&(!w||this.ModifiedElementsAreEqual(d.modifiedStart,d.modifiedStart+d.modifiedLength));){const r=this.ElementsAreStrictEqual(d.originalStart,d.modifiedStart);if(this.ElementsAreStrictEqual(d.originalStart+d.originalLength,d.modifiedStart+d.modifiedLength)&&!r)break;d.originalStart++,d.modifiedStart++}let p=[null];if(a<e.length-1&&this.ChangesOverlap(e[a],e[a+1],p)){e[a]=p[0],e.splice(a+1,1),a--;continue}}for(let a=e.length-1;a>=0;a--){const d=e[a];let S=0,b=0;if(a>0){const s=e[a-1];S=s.originalStart+s.originalLength,b=s.modifiedStart+s.modifiedLength}const v=d.originalLength>0,w=d.modifiedLength>0;let p=0,r=this._boundaryScore(d.originalStart,d.originalLength,d.modifiedStart,d.modifiedLength);for(let s=1;;s++){const c=d.originalStart-s,g=d.modifiedStart-s;if(c<S||g<b||v&&!this.OriginalElementsAreEqual(c,c+d.originalLength)||w&&!this.ModifiedElementsAreEqual(g,g+d.modifiedLength))break;const _=(c===S&&g===b?5:0)+this._boundaryScore(c,d.originalLength,g,d.modifiedLength);_>r&&(r=_,p=s)}d.originalStart-=p,d.modifiedStart-=p;const i=[null];if(a>0&&this.ChangesOverlap(e[a-1],e[a],i)){e[a-1]=i[0],e.splice(a,1),a++;continue}}if(this._hasStrings)for(let a=1,d=e.length;a<d;a++){const S=e[a-1],b=e[a],v=b.originalStart-S.originalStart-S.originalLength,w=S.originalStart,p=b.originalStart+b.originalLength,r=p-w,i=S.modifiedStart,s=b.modifiedStart+b.modifiedLength,c=s-i;if(v<5&&r<20&&c<20){const g=this._findBetterContiguousSequence(w,r,i,c,v);if(g){const[l,_]=g;(l!==S.originalStart+S.originalLength||_!==S.modifiedStart+S.modifiedLength)&&(S.originalLength=l-S.originalStart,S.modifiedLength=_-S.modifiedStart,b.originalStart=l+v,b.modifiedStart=_+v,b.originalLength=p-b.originalStart,b.modifiedLength=s-b.modifiedStart)}}}return e}_findBetterContiguousSequence(e,a,d,S,b){if(a<b||S<b)return null;const v=e+a-b+1,w=d+S-b+1;let p=0,r=0,i=0;for(let s=e;s<v;s++)for(let c=d;c<w;c++){const g=this._contiguousSequenceScore(s,c,b);g>0&&g>p&&(p=g,r=s,i=c)}return p>0?[r,i]:null}_contiguousSequenceScore(e,a,d){let S=0;for(let b=0;b<d;b++){if(!this.ElementsAreEqual(e+b,a+b))return 0;S+=this._originalStringElements[e+b].length}return S}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,a){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(a>0){const d=e+a;if(this._OriginalIsBoundary(d-1)||this._OriginalIsBoundary(d))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,a){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(a>0){const d=e+a;if(this._ModifiedIsBoundary(d-1)||this._ModifiedIsBoundary(d))return!0}return!1}_boundaryScore(e,a,d,S){const b=this._OriginalRegionIsBoundary(e,a)?1:0,v=this._ModifiedRegionIsBoundary(d,S)?1:0;return b+v}ConcatenateChanges(e,a){let d=[];if(e.length===0||a.length===0)return a.length>0?a:e;if(this.ChangesOverlap(e[e.length-1],a[0],d)){const S=new Array(e.length+a.length-1);return m.Copy(e,0,S,0,e.length-1),S[e.length-1]=d[0],m.Copy(a,1,S,e.length,a.length-1),S}else{const S=new Array(e.length+a.length);return m.Copy(e,0,S,0,e.length),m.Copy(a,0,S,e.length,a.length),S}}ChangesOverlap(e,a,d){if(L.Assert(e.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),L.Assert(e.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=a.originalStart||e.modifiedStart+e.modifiedLength>=a.modifiedStart){const S=e.originalStart;let b=e.originalLength;const v=e.modifiedStart;let w=e.modifiedLength;return e.originalStart+e.originalLength>=a.originalStart&&(b=a.originalStart+a.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=a.modifiedStart&&(w=a.modifiedStart+a.modifiedLength-e.modifiedStart),d[0]=new M.DiffChange(S,b,v,w),!0}else return d[0]=null,!1}ClipDiagonalBound(e,a,d,S){if(e>=0&&e<S)return e;const b=d,v=S-d-1,w=a%2==0;if(e<0){const p=b%2==0;return w===p?0:1}else{const p=v%2==0;return w===p?S-1:S-2}}}n.LcsDiff=h}),$(j[7],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.assertNever=n.withNullAsUndefined=n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isNumber=n.isObject=n.isString=n.isArray=void 0;function M(i){return Array.isArray(i)}n.isArray=M;function R(i){return typeof i=="string"}n.isString=R;function E(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}n.isObject=E;function o(i){return typeof i=="number"&&!isNaN(i)}n.isNumber=o;function L(i){return i===!0||i===!1}n.isBoolean=L;function m(i){return typeof i=="undefined"}n.isUndefined=m;function u(i){return!h(i)}n.isDefined=u;function h(i){return m(i)||i===null}n.isUndefinedOrNull=h;function C(i,s){if(!i)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}n.assertType=C;function e(i){if(h(i))throw new Error("Assertion Failed: argument is undefined or null");return i}n.assertIsDefined=e;function a(i){return typeof i=="function"}n.isFunction=a;function d(i,s){const c=Math.min(i.length,s.length);for(let g=0;g<c;g++)S(i[g],s[g])}n.validateConstraints=d;function S(i,s){if(R(s)){if(typeof i!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(a(s)){try{if(i instanceof s)return}catch(c){}if(!h(i)&&i.constructor===s||s.length===1&&s.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=S;function b(i){let s=[],c=Object.getPrototypeOf(i);for(;Object.prototype!==c;)s=s.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return s}n.getAllPropertyNames=b;function v(i){const s=[];for(const c of b(i))typeof i[c]=="function"&&s.push(c);return s}n.getAllMethodNames=v;function w(i,s){const c=l=>function(){const _=Array.prototype.slice.call(arguments,0);return s(l,_)};let g={};for(const l of i)g[l]=c(l);return g}n.createProxyObject=w;function p(i){return i===null?void 0:i}n.withNullAsUndefined=p;function r(i,s="Unreachable"){throw new Error(s)}n.assertNever=r}),$(j[25],G([0,1,7]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getOrDefault=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function R(e){if(!e||typeof e!="object"||e instanceof RegExp)return e;const a=Array.isArray(e)?[]:{};return Object.keys(e).forEach(d=>{e[d]&&typeof e[d]=="object"?a[d]=R(e[d]):a[d]=e[d]}),a}n.deepClone=R;function E(e){if(!e||typeof e!="object")return e;const a=[e];for(;a.length>0;){const d=a.shift();Object.freeze(d);for(const S in d)if(o.call(d,S)){const b=d[S];typeof b=="object"&&!Object.isFrozen(b)&&a.push(b)}}return e}n.deepFreeze=E;const o=Object.prototype.hasOwnProperty;function L(e,a){return m(e,a,new Set)}n.cloneAndChange=L;function m(e,a,d){if((0,M.isUndefinedOrNull)(e))return e;const S=a(e);if(typeof S!="undefined")return S;if((0,M.isArray)(e)){const b=[];for(const v of e)b.push(m(v,a,d));return b}if((0,M.isObject)(e)){if(d.has(e))throw new Error("Cannot clone recursive data-structure");d.add(e);const b={};for(let v in e)o.call(e,v)&&(b[v]=m(e[v],a,d));return d.delete(e),b}return e}function u(e,a,d=!0){return(0,M.isObject)(e)?((0,M.isObject)(a)&&Object.keys(a).forEach(S=>{S in e?d&&((0,M.isObject)(e[S])&&(0,M.isObject)(a[S])?u(e[S],a[S],d):e[S]=a[S]):e[S]=a[S]}),e):a}n.mixin=u;function h(e,a){if(e===a)return!0;if(e==null||a===null||a===void 0||typeof e!=typeof a||typeof e!="object"||Array.isArray(e)!==Array.isArray(a))return!1;let d,S;if(Array.isArray(e)){if(e.length!==a.length)return!1;for(d=0;d<e.length;d++)if(!h(e[d],a[d]))return!1}else{const b=[];for(S in e)b.push(S);b.sort();const v=[];for(S in a)v.push(S);if(v.sort(),!h(b,v))return!1;for(d=0;d<b.length;d++)if(!h(e[b[d]],a[b[d]]))return!1}return!0}n.equals=h;function C(e,a,d){const S=a(e);return typeof S=="undefined"?d:S}n.getOrDefault=C}),$(j[12],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function M(E){return E<0?0:E>255?255:E|0}n.toUint8=M;function R(E){return E<0?0:E>4294967295?4294967295:E|0}n.toUint32=R}),$(j[13],G([0,1,22,2]),function(I,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const E=/^\w[\w\d+.-]*$/,o=/^\//,L=/^\/\//;function m(l,_){if(!l.scheme&&_)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!E.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!o.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(l,_){return!l&&!_?"file":l}function h(l,_){switch(l){case"https":case"http":case"file":_?_[0]!==e&&(_=e+_):_=e;break}return _}const C="",e="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(_,f,N,A,y,D=!1){typeof _=="object"?(this.scheme=_.scheme||C,this.authority=_.authority||C,this.path=_.path||C,this.query=_.query||C,this.fragment=_.fragment||C):(this.scheme=u(_,D),this.authority=f||C,this.path=h(this.scheme,N||C),this.query=A||C,this.fragment=y||C,m(this,D))}static isUri(_){return _ instanceof d?!0:_?typeof _.authority=="string"&&typeof _.fragment=="string"&&typeof _.path=="string"&&typeof _.query=="string"&&typeof _.scheme=="string"&&typeof _.fsPath=="string"&&typeof _.with=="function"&&typeof _.toString=="function":!1}get fsPath(){return r(this,!1)}with(_){if(!_)return this;let{scheme:f,authority:N,path:A,query:y,fragment:D}=_;return f===void 0?f=this.scheme:f===null&&(f=C),N===void 0?N=this.authority:N===null&&(N=C),A===void 0?A=this.path:A===null&&(A=C),y===void 0?y=this.query:y===null&&(y=C),D===void 0?D=this.fragment:D===null&&(D=C),f===this.scheme&&N===this.authority&&A===this.path&&y===this.query&&D===this.fragment?this:new b(f,N,A,y,D)}static parse(_,f=!1){const N=a.exec(_);return N?new b(N[2]||C,g(N[4]||C),g(N[5]||C),g(N[7]||C),g(N[9]||C),f):new b(C,C,C,C,C)}static file(_){let f=C;if(R.isWindows&&(_=_.replace(/\\/g,e)),_[0]===e&&_[1]===e){const N=_.indexOf(e,2);N===-1?(f=_.substring(2),_=e):(f=_.substring(2,N),_=_.substring(N)||e)}return new b("file",f,_,C,C)}static from(_){const f=new b(_.scheme,_.authority,_.path,_.query,_.fragment);return m(f,!0),f}static joinPath(_,...f){if(!_.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let N;return R.isWindows&&_.scheme==="file"?N=d.file(M.win32.join(r(_,!0),...f)).path:N=M.posix.join(_.path,...f),_.with({path:N})}toString(_=!1){return i(this,_)}toJSON(){return this}static revive(_){if(_){if(_ instanceof d)return _;{const f=new b(_);return f._formatted=_.external,f._fsPath=_._sep===S?_.fsPath:null,f}}else return _}}n.URI=d;const S=R.isWindows?1:void 0;class b extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(_=!1){return _?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const _={$mid:1};return this._fsPath&&(_.fsPath=this._fsPath,_._sep=S),this._formatted&&(_.external=this._formatted),this.path&&(_.path=this.path),this.scheme&&(_.scheme=this.scheme),this.authority&&(_.authority=this.authority),this.query&&(_.query=this.query),this.fragment&&(_.fragment=this.fragment),_}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(l,_){let f,N=-1;for(let A=0;A<l.length;A++){const y=l.charCodeAt(A);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||_&&y===47)N!==-1&&(f+=encodeURIComponent(l.substring(N,A)),N=-1),f!==void 0&&(f+=l.charAt(A));else{f===void 0&&(f=l.substr(0,A));const D=v[y];D!==void 0?(N!==-1&&(f+=encodeURIComponent(l.substring(N,A)),N=-1),f+=D):N===-1&&(N=A)}}return N!==-1&&(f+=encodeURIComponent(l.substring(N))),f!==void 0?f:l}function p(l){let _;for(let f=0;f<l.length;f++){const N=l.charCodeAt(f);N===35||N===63?(_===void 0&&(_=l.substr(0,f)),_+=v[N]):_!==void 0&&(_+=l[f])}return _!==void 0?_:l}function r(l,_){let f;return l.authority&&l.path.length>1&&l.scheme==="file"?f=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?_?f=l.path.substr(1):f=l.path[1].toLowerCase()+l.path.substr(2):f=l.path,R.isWindows&&(f=f.replace(/\//g,"\\")),f}n.uriToFsPath=r;function i(l,_){const f=_?p:w;let N="",{scheme:A,authority:y,path:D,query:k,fragment:B}=l;if(A&&(N+=A,N+=":"),(y||A==="file")&&(N+=e,N+=e),y){let U=y.indexOf("@");if(U!==-1){const T=y.substr(0,U);y=y.substr(U+1),U=T.indexOf(":"),U===-1?N+=f(T,!1):(N+=f(T.substr(0,U),!1),N+=":",N+=f(T.substr(U+1),!1)),N+="@"}y=y.toLowerCase(),U=y.indexOf(":"),U===-1?N+=f(y,!1):(N+=f(y.substr(0,U),!1),N+=y.substr(U))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const U=D.charCodeAt(1);U>=65&&U<=90&&(D=`/${String.fromCharCode(U+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const U=D.charCodeAt(0);U>=65&&U<=90&&(D=`${String.fromCharCode(U+32)}:${D.substr(2)}`)}N+=f(D,!0)}return k&&(N+="?",N+=f(k,!1)),B&&(N+="#",N+=_?B:w(B,!1)),N}function s(l){try{return decodeURIComponent(l)}catch(_){return l.length>3?l.substr(0,3)+s(l.substr(3)):l}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function g(l){return l.match(c)?l.replace(c,_=>s(_)):l}}),$(j[40],G([0,1,8,6,9,2,7,3]),function(I,n,M,R,E,o,L,m){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const u="$initialize";let h=!1;function C(g){!o.isWeb||(h||(h=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(g.message))}n.logOnceWebWorkerWarning=C;class e{constructor(l,_,f,N){this.vsWorker=l,this.req=_,this.method=f,this.args=N,this.type=0}}class a{constructor(l,_,f,N){this.vsWorker=l,this.seq=_,this.res=f,this.err=N,this.type=1}}class d{constructor(l,_,f,N){this.vsWorker=l,this.req=_,this.eventName=f,this.arg=N,this.type=2}}class S{constructor(l,_,f){this.vsWorker=l,this.req=_,this.event=f,this.type=3}}class b{constructor(l,_){this.vsWorker=l,this.req=_,this.type=4}}class v{constructor(l){this._workerId=-1,this._handler=l,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(l){this._workerId=l}sendMessage(l,_){const f=String(++this._lastSentReq);return new Promise((N,A)=>{this._pendingReplies[f]={resolve:N,reject:A},this._send(new e(this._workerId,f,l,_))})}listen(l,_){let f=null;const N=new R.Emitter({onFirstListenerAdd:()=>{f=String(++this._lastSentReq),this._pendingEmitters.set(f,N),this._send(new d(this._workerId,f,l,_))},onLastListenerRemove:()=>{this._pendingEmitters.delete(f),this._send(new b(this._workerId,f)),f=null}});return N.event}handleMessage(l){!l||!l.vsWorker||this._workerId!==-1&&l.vsWorker!==this._workerId||this._handleMessage(l)}_handleMessage(l){switch(l.type){case 1:return this._handleReplyMessage(l);case 0:return this._handleRequestMessage(l);case 2:return this._handleSubscribeEventMessage(l);case 3:return this._handleEventMessage(l);case 4:return this._handleUnsubscribeEventMessage(l)}}_handleReplyMessage(l){if(!this._pendingReplies[l.seq]){console.warn("Got reply to unknown seq");return}let _=this._pendingReplies[l.seq];if(delete this._pendingReplies[l.seq],l.err){let f=l.err;l.err.$isError&&(f=new Error,f.name=l.err.name,f.message=l.err.message,f.stack=l.err.stack),_.reject(f);return}_.resolve(l.res)}_handleRequestMessage(l){let _=l.req;this._handler.handleMessage(l.method,l.args).then(N=>{this._send(new a(this._workerId,_,N,void 0))},N=>{N.detail instanceof Error&&(N.detail=(0,M.transformErrorForSerialization)(N.detail)),this._send(new a(this._workerId,_,void 0,(0,M.transformErrorForSerialization)(N)))})}_handleSubscribeEventMessage(l){const _=l.req,f=this._handler.handleEvent(l.eventName,l.arg)(N=>{this._send(new S(this._workerId,_,N))});this._pendingEvents.set(_,f)}_handleEventMessage(l){if(!this._pendingEmitters.has(l.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(l.req).fire(l.event)}_handleUnsubscribeEventMessage(l){if(!this._pendingEvents.has(l.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(l.req).dispose(),this._pendingEvents.delete(l.req)}_send(l){let _=[];if(l.type===0)for(let f=0;f<l.args.length;f++)l.args[f]instanceof ArrayBuffer&&_.push(l.args[f]);else l.type===1&&l.res instanceof ArrayBuffer&&_.push(l.res);this._handler.sendMessage(l,_)}}class w extends E.Disposable{constructor(l,_,f){super();let N=null;this._worker=this._register(l.create("vs/base/common/worker/simpleWorker",B=>{this._protocol.handleMessage(B)},B=>{N&&N(B)})),this._protocol=new v({sendMessage:(B,U)=>{this._worker.postMessage(B,U)},handleMessage:(B,U)=>{if(typeof f[B]!="function")return Promise.reject(new Error("Missing method "+B+" on main thread host."));try{return Promise.resolve(f[B].apply(f,U))}catch(T){return Promise.reject(T)}},handleEvent:(B,U)=>{if(r(B)){const T=f[B].call(f,U);if(typeof T!="function")throw new Error(`Missing dynamic event ${B} on main thread host.`);return T}if(p(B)){const T=f[B];if(typeof T!="function")throw new Error(`Missing event ${B} on main thread host.`);return T}throw new Error(`Malformed event name ${B}`)}}),this._protocol.setWorkerId(this._worker.getId());let A=null;typeof o.globals.require!="undefined"&&typeof o.globals.require.getConfig=="function"?A=o.globals.require.getConfig():typeof o.globals.requirejs!="undefined"&&(A=o.globals.requirejs.s.contexts._.config);const y=L.getAllMethodNames(f);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(A)),_,y]);const D=(B,U)=>this._request(B,U),k=(B,U)=>this._protocol.listen(B,U);this._lazyProxy=new Promise((B,U)=>{N=U,this._onModuleLoaded.then(T=>{B(i(T,D,k))},T=>{U(T),this._onError("Worker failed to load "+_,T)})})}getProxyObject(){return this._lazyProxy}_request(l,_){return new Promise((f,N)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(l,_).then(f,N)},N)})}_onError(l,_){console.error(l),console.info(_)}}n.SimpleWorkerClient=w;function p(g){return g[0]==="o"&&g[1]==="n"&&m.isUpperAsciiLetter(g.charCodeAt(2))}function r(g){return/^onDynamic/.test(g)&&m.isUpperAsciiLetter(g.charCodeAt(9))}function i(g,l,_){const f=y=>function(){const D=Array.prototype.slice.call(arguments,0);return l(y,D)},N=y=>function(D){return _(y,D)};let A={};for(const y of g){if(r(y)){A[y]=N(y);continue}if(p(y)){A[y]=_(y,void 0);continue}A[y]=f(y)}return A}class s{constructor(l,_){this._requestHandlerFactory=_,this._requestHandler=null,this._protocol=new v({sendMessage:(f,N)=>{l(f,N)},handleMessage:(f,N)=>this._handleMessage(f,N),handleEvent:(f,N)=>this._handleEvent(f,N)})}onmessage(l){this._protocol.handleMessage(l)}_handleMessage(l,_){if(l===u)return this.initialize(_[0],_[1],_[2],_[3]);if(!this._requestHandler||typeof this._requestHandler[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this._requestHandler[l].apply(this._requestHandler,_))}catch(f){return Promise.reject(f)}}_handleEvent(l,_){if(!this._requestHandler)throw new Error("Missing requestHandler");if(r(l)){const f=this._requestHandler[l].call(this._requestHandler,_);if(typeof f!="function")throw new Error(`Missing dynamic event ${l} on request handler.`);return f}if(p(l)){const f=this._requestHandler[l];if(typeof f!="function")throw new Error(`Missing event ${l} on request handler.`);return f}throw new Error(`Malformed event name ${l}`)}initialize(l,_,f,N){this._protocol.setWorkerId(l);const D=i(N,(k,B)=>this._protocol.sendMessage(k,B),(k,B)=>this._protocol.listen(k,B));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve(L.getAllMethodNames(this._requestHandler))):(_&&(typeof _.baseUrl!="undefined"&&delete _.baseUrl,typeof _.paths!="undefined"&&typeof _.paths.vs!="undefined"&&delete _.paths.vs,typeof _.trustedTypesPolicy!==void 0&&delete _.trustedTypesPolicy,_.catchError=!0,o.globals.require.config(_)),new Promise((k,B)=>{(o.globals.require||I)([f],T=>{if(this._requestHandler=T.create(D),!this._requestHandler){B(new Error("No RequestHandler!"));return}k(L.getAllMethodNames(this._requestHandler))},B)}))}}n.SimpleWorkerServer=s;function c(g){return new s(g,null)}n.create=c}),$(j[14],G([0,1,12]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class R{constructor(L){let m=(0,M.toUint8)(L);this._defaultValue=m,this._asciiMap=R._createAsciiMap(m),this._map=new Map}static _createAsciiMap(L){let m=new Uint8Array(256);for(let u=0;u<256;u++)m[u]=L;return m}set(L,m){let u=(0,M.toUint8)(m);L>=0&&L<256?this._asciiMap[L]=u:this._map.set(L,u)}get(L){return L>=0&&L<256?this._asciiMap[L]:this._map.get(L)||this._defaultValue}}n.CharacterClassifier=R;class E{constructor(){this._actual=new R(0)}add(L){this._actual.set(L,1)}has(L){return this._actual.get(L)===1}}n.CharacterSet=E}),$(j[26],G([0,1,14]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class R extends M.CharacterClassifier{constructor(L){super(0);for(let m=0,u=L.length;m<u;m++)this.set(L.charCodeAt(m),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=R;function E(o){let L={};return m=>(L.hasOwnProperty(m)||(L[m]=o(m)),L[m])}n.getMapForWordSeparators=E(o=>new R(o))}),$(j[4],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class M{constructor(E,o){this.lineNumber=E,this.column=o}with(E=this.lineNumber,o=this.column){return E===this.lineNumber&&o===this.column?this:new M(E,o)}delta(E=0,o=0){return this.with(this.lineNumber+E,this.column+o)}equals(E){return M.equals(this,E)}static equals(E,o){return!E&&!o?!0:!!E&&!!o&&E.lineNumber===o.lineNumber&&E.column===o.column}isBefore(E){return M.isBefore(this,E)}static isBefore(E,o){return E.lineNumber<o.lineNumber?!0:o.lineNumber<E.lineNumber?!1:E.column<o.column}isBeforeOrEqual(E){return M.isBeforeOrEqual(this,E)}static isBeforeOrEqual(E,o){return E.lineNumber<o.lineNumber?!0:o.lineNumber<E.lineNumber?!1:E.column<=o.column}static compare(E,o){let L=E.lineNumber|0,m=o.lineNumber|0;if(L===m){let u=E.column|0,h=o.column|0;return u-h}return L-m}clone(){return new M(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(E){return new M(E.lineNumber,E.column)}static isIPosition(E){return E&&typeof E.lineNumber=="number"&&typeof E.column=="number"}}n.Position=M}),$(j[5],G([0,1,4]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class R{constructor(o,L,m,u){o>m||o===m&&L>u?(this.startLineNumber=m,this.startColumn=u,this.endLineNumber=o,this.endColumn=L):(this.startLineNumber=o,this.startColumn=L,this.endLineNumber=m,this.endColumn=u)}isEmpty(){return R.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return R.containsPosition(this,o)}static containsPosition(o,L){return!(L.lineNumber<o.startLineNumber||L.lineNumber>o.endLineNumber||L.lineNumber===o.startLineNumber&&L.column<o.startColumn||L.lineNumber===o.endLineNumber&&L.column>o.endColumn)}static strictContainsPosition(o,L){return!(L.lineNumber<o.startLineNumber||L.lineNumber>o.endLineNumber||L.lineNumber===o.startLineNumber&&L.column<=o.startColumn||L.lineNumber===o.endLineNumber&&L.column>=o.endColumn)}containsRange(o){return R.containsRange(this,o)}static containsRange(o,L){return!(L.startLineNumber<o.startLineNumber||L.endLineNumber<o.startLineNumber||L.startLineNumber>o.endLineNumber||L.endLineNumber>o.endLineNumber||L.startLineNumber===o.startLineNumber&&L.startColumn<o.startColumn||L.endLineNumber===o.endLineNumber&&L.endColumn>o.endColumn)}strictContainsRange(o){return R.strictContainsRange(this,o)}static strictContainsRange(o,L){return!(L.startLineNumber<o.startLineNumber||L.endLineNumber<o.startLineNumber||L.startLineNumber>o.endLineNumber||L.endLineNumber>o.endLineNumber||L.startLineNumber===o.startLineNumber&&L.startColumn<=o.startColumn||L.endLineNumber===o.endLineNumber&&L.endColumn>=o.endColumn)}plusRange(o){return R.plusRange(this,o)}static plusRange(o,L){let m,u,h,C;return L.startLineNumber<o.startLineNumber?(m=L.startLineNumber,u=L.startColumn):L.startLineNumber===o.startLineNumber?(m=L.startLineNumber,u=Math.min(L.startColumn,o.startColumn)):(m=o.startLineNumber,u=o.startColumn),L.endLineNumber>o.endLineNumber?(h=L.endLineNumber,C=L.endColumn):L.endLineNumber===o.endLineNumber?(h=L.endLineNumber,C=Math.max(L.endColumn,o.endColumn)):(h=o.endLineNumber,C=o.endColumn),new R(m,u,h,C)}intersectRanges(o){return R.intersectRanges(this,o)}static intersectRanges(o,L){let m=o.startLineNumber,u=o.startColumn,h=o.endLineNumber,C=o.endColumn,e=L.startLineNumber,a=L.startColumn,d=L.endLineNumber,S=L.endColumn;return m<e?(m=e,u=a):m===e&&(u=Math.max(u,a)),h>d?(h=d,C=S):h===d&&(C=Math.min(C,S)),m>h||m===h&&u>C?null:new R(m,u,h,C)}equalsRange(o){return R.equalsRange(this,o)}static equalsRange(o,L){return!!o&&!!L&&o.startLineNumber===L.startLineNumber&&o.startColumn===L.startColumn&&o.endLineNumber===L.endLineNumber&&o.endColumn===L.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(o){return new M.Position(o.endLineNumber,o.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(o){return new M.Position(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,L){return new R(this.startLineNumber,this.startColumn,o,L)}setStartPosition(o,L){return new R(o,L,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(o){return new R(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}static fromPositions(o,L=o){return new R(o.lineNumber,o.column,L.lineNumber,L.column)}static lift(o){return o?new R(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,L){return!(o.endLineNumber<L.startLineNumber||o.endLineNumber===L.startLineNumber&&o.endColumn<L.startColumn||L.endLineNumber<o.startLineNumber||L.endLineNumber===o.startLineNumber&&L.endColumn<o.startColumn)}static areIntersecting(o,L){return!(o.endLineNumber<L.startLineNumber||o.endLineNumber===L.startLineNumber&&o.endColumn<=L.startColumn||L.endLineNumber<o.startLineNumber||L.endLineNumber===o.startLineNumber&&L.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,L){if(o&&L){const h=o.startLineNumber|0,C=L.startLineNumber|0;if(h===C){const e=o.startColumn|0,a=L.startColumn|0;if(e===a){const d=o.endLineNumber|0,S=L.endLineNumber|0;if(d===S){const b=o.endColumn|0,v=L.endColumn|0;return b-v}return d-S}return e-a}return h-C}return(o?1:0)-(L?1:0)}static compareRangesUsingEnds(o,L){return o.endLineNumber===L.endLineNumber?o.endColumn===L.endColumn?o.startLineNumber===L.startLineNumber?o.startColumn-L.startColumn:o.startLineNumber-L.startLineNumber:o.endColumn-L.endColumn:o.endLineNumber-L.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}}n.Range=R}),$(j[27],G([0,1,4,5]),function(I,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class E extends R.Range{constructor(L,m,u,h){super(L,m,u,h);this.selectionStartLineNumber=L,this.selectionStartColumn=m,this.positionLineNumber=u,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(L){return E.selectionsEqual(this,L)}static selectionsEqual(L,m){return L.selectionStartLineNumber===m.selectionStartLineNumber&&L.selectionStartColumn===m.selectionStartColumn&&L.positionLineNumber===m.positionLineNumber&&L.positionColumn===m.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(L,m){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,L,m):new E(L,m,this.startLineNumber,this.startColumn)}getPosition(){return new M.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new M.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(L,m){return this.getDirection()===0?new E(L,m,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,L,m)}static fromPositions(L,m=L){return new E(L.lineNumber,L.column,m.lineNumber,m.column)}static fromRange(L,m){return m===0?new E(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):new E(L.endLineNumber,L.endColumn,L.startLineNumber,L.startColumn)}static liftSelection(L){return new E(L.selectionStartLineNumber,L.selectionStartColumn,L.positionLineNumber,L.positionColumn)}static selectionsArrEqual(L,m){if(L&&!m||!L&&m)return!1;if(!L&&!m)return!0;if(L.length!==m.length)return!1;for(let u=0,h=L.length;u<h;u++)if(!this.selectionsEqual(L[u],m[u]))return!1;return!0}static isISelection(L){return L&&typeof L.selectionStartLineNumber=="number"&&typeof L.selectionStartColumn=="number"&&typeof L.positionLineNumber=="number"&&typeof L.positionColumn=="number"}static createWithDirection(L,m,u,h,C){return C===0?new E(L,m,u,h):new E(u,h,L,m)}}n.Selection=E}),$(j[28],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationResult2=n.TokenizationResult=n.Token=void 0;class M{constructor(L,m,u){this._tokenBrand=void 0,this.offset=L,this.type=m,this.language=u}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=M;class R{constructor(L,m){this._tokenizationResultBrand=void 0,this.tokens=L,this.endState=m}}n.TokenizationResult=R;class E{constructor(L,m){this._tokenizationResult2Brand=void 0,this.tokens=L,this.endState=m}}n.TokenizationResult2=E}),$(j[29],G([0,1,11,3]),function(I,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=void 0;const E=3;function o(b,v,w,p){return new M.LcsDiff(b,v,w).ComputeDiff(p)}class L{constructor(v){const w=[],p=[];for(let r=0,i=v.length;r<i;r++)w[r]=a(v[r],1),p[r]=d(v[r],1);this.lines=v,this._startColumns=w,this._endColumns=p}getElements(){const v=[];for(let w=0,p=this.lines.length;w<p;w++)v[w]=this.lines[w].substring(this._startColumns[w]-1,this._endColumns[w]-1);return v}getStrictElement(v){return this.lines[v]}getStartLineNumber(v){return v+1}getEndLineNumber(v){return v+1}createCharSequence(v,w,p){const r=[],i=[],s=[];let c=0;for(let g=w;g<=p;g++){const l=this.lines[g],_=v?this._startColumns[g]:1,f=v?this._endColumns[g]:l.length+1;for(let N=_;N<f;N++)r[c]=l.charCodeAt(N-1),i[c]=g+1,s[c]=N,c++}return new m(r,i,s)}}class m{constructor(v,w,p){this._charCodes=v,this._lineNumbers=w,this._columns=p}getElements(){return this._charCodes}getStartLineNumber(v){return this._lineNumbers[v]}getStartColumn(v){return this._columns[v]}getEndLineNumber(v){return this._lineNumbers[v]}getEndColumn(v){return this._columns[v]+1}}class u{constructor(v,w,p,r,i,s,c,g){this.originalStartLineNumber=v,this.originalStartColumn=w,this.originalEndLineNumber=p,this.originalEndColumn=r,this.modifiedStartLineNumber=i,this.modifiedStartColumn=s,this.modifiedEndLineNumber=c,this.modifiedEndColumn=g}static createFromDiffChange(v,w,p){let r,i,s,c,g,l,_,f;return v.originalLength===0?(r=0,i=0,s=0,c=0):(r=w.getStartLineNumber(v.originalStart),i=w.getStartColumn(v.originalStart),s=w.getEndLineNumber(v.originalStart+v.originalLength-1),c=w.getEndColumn(v.originalStart+v.originalLength-1)),v.modifiedLength===0?(g=0,l=0,_=0,f=0):(g=p.getStartLineNumber(v.modifiedStart),l=p.getStartColumn(v.modifiedStart),_=p.getEndLineNumber(v.modifiedStart+v.modifiedLength-1),f=p.getEndColumn(v.modifiedStart+v.modifiedLength-1)),new u(r,i,s,c,g,l,_,f)}}function h(b){if(b.length<=1)return b;const v=[b[0]];let w=v[0];for(let p=1,r=b.length;p<r;p++){const i=b[p],s=i.originalStart-(w.originalStart+w.originalLength),c=i.modifiedStart-(w.modifiedStart+w.modifiedLength);Math.min(s,c)<E?(w.originalLength=i.originalStart+i.originalLength-w.originalStart,w.modifiedLength=i.modifiedStart+i.modifiedLength-w.modifiedStart):(v.push(i),w=i)}return v}class C{constructor(v,w,p,r,i){this.originalStartLineNumber=v,this.originalEndLineNumber=w,this.modifiedStartLineNumber=p,this.modifiedEndLineNumber=r,this.charChanges=i}static createFromDiffResult(v,w,p,r,i,s,c){let g,l,_,f,N;if(w.originalLength===0?(g=p.getStartLineNumber(w.originalStart)-1,l=0):(g=p.getStartLineNumber(w.originalStart),l=p.getEndLineNumber(w.originalStart+w.originalLength-1)),w.modifiedLength===0?(_=r.getStartLineNumber(w.modifiedStart)-1,f=0):(_=r.getStartLineNumber(w.modifiedStart),f=r.getEndLineNumber(w.modifiedStart+w.modifiedLength-1)),s&&w.originalLength>0&&w.originalLength<20&&w.modifiedLength>0&&w.modifiedLength<20&&i()){const A=p.createCharSequence(v,w.originalStart,w.originalStart+w.originalLength-1),y=r.createCharSequence(v,w.modifiedStart,w.modifiedStart+w.modifiedLength-1);let D=o(A,y,i,!0).changes;c&&(D=h(D)),N=[];for(let k=0,B=D.length;k<B;k++)N.push(u.createFromDiffChange(D[k],A,y))}return new C(g,l,_,f,N)}}class e{constructor(v,w,p){this.shouldComputeCharChanges=p.shouldComputeCharChanges,this.shouldPostProcessCharChanges=p.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=p.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=p.shouldMakePrettyDiff,this.originalLines=v,this.modifiedLines=w,this.original=new L(v),this.modified=new L(w),this.continueLineDiff=S(p.maxComputationTime),this.continueCharDiff=S(p.maxComputationTime===0?0:Math.min(p.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:[{modifiedEndColumn:0,modifiedEndLineNumber:0,modifiedStartColumn:0,modifiedStartLineNumber:0,originalEndColumn:0,originalEndLineNumber:0,originalStartColumn:0,originalStartLineNumber:0}]}]};const v=o(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),w=v.changes,p=v.quitEarly;if(this.shouldIgnoreTrimWhitespace){const c=[];for(let g=0,l=w.length;g<l;g++)c.push(C.createFromDiffResult(this.shouldIgnoreTrimWhitespace,w[g],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:p,changes:c}}const r=[];let i=0,s=0;for(let c=-1,g=w.length;c<g;c++){const l=c+1<g?w[c+1]:null,_=l?l.originalStart:this.originalLines.length,f=l?l.modifiedStart:this.modifiedLines.length;for(;i<_&&s<f;){const N=this.originalLines[i],A=this.modifiedLines[s];if(N!==A){{let y=a(N,1),D=a(A,1);for(;y>1&&D>1;){const k=N.charCodeAt(y-2),B=A.charCodeAt(D-2);if(k!==B)break;y--,D--}(y>1||D>1)&&this._pushTrimWhitespaceCharChange(r,i+1,1,y,s+1,1,D)}{let y=d(N,1),D=d(A,1);const k=N.length+1,B=A.length+1;for(;y<k&&D<B;){const U=N.charCodeAt(y-1),T=N.charCodeAt(D-1);if(U!==T)break;y++,D++}(y<k||D<B)&&this._pushTrimWhitespaceCharChange(r,i+1,y,k,s+1,D,B)}}i++,s++}l&&(r.push(C.createFromDiffResult(this.shouldIgnoreTrimWhitespace,l,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),i+=l.originalLength,s+=l.modifiedLength)}return{quitEarly:p,changes:r}}_pushTrimWhitespaceCharChange(v,w,p,r,i,s,c){if(this._mergeTrimWhitespaceCharChange(v,w,p,r,i,s,c))return;let g;this.shouldComputeCharChanges&&(g=[new u(w,p,w,r,i,s,i,c)]),v.push(new C(w,w,i,i,g))}_mergeTrimWhitespaceCharChange(v,w,p,r,i,s,c){const g=v.length;if(g===0)return!1;const l=v[g-1];return l.originalEndLineNumber===0||l.modifiedEndLineNumber===0?!1:l.originalEndLineNumber+1===w&&l.modifiedEndLineNumber+1===i?(l.originalEndLineNumber=w,l.modifiedEndLineNumber=i,this.shouldComputeCharChanges&&l.charChanges&&l.charChanges.push(new u(w,p,w,r,i,s,i,c)),!0):!1}}n.DiffComputer=e;function a(b,v){const w=R.firstNonWhitespaceIndex(b);return w===-1?v:w+1}function d(b,v){const w=R.lastNonWhitespaceIndex(b);return w===-1?v:w+2}function S(b){if(b===0)return()=>!0;const v=Date.now();return()=>Date.now()-v<b}}),$(j[30],G([0,1,25]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.ApplyEditsResult=n.ValidAnnotatedEditOperation=n.IndentGuideHorizontalLine=n.IndentGuide=n.HorizontalGuidesState=n.FindMatch=n.TextModelResolvedOptions=n.MinimapPosition=n.OverviewRulerLane=void 0;var R;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(R=n.OverviewRulerLane||(n.OverviewRulerLane={}));var E;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(E=n.MinimapPosition||(n.MinimapPosition={}));class o{constructor(d){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace),this.bracketPairColorizationOptions=d.bracketPairColorizationOptions}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace&&(0,M.equals)(this.bracketPairColorizationOptions,d.bracketPairColorizationOptions)}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}n.TextModelResolvedOptions=o;class L{constructor(d,S){this._findMatchBrand=void 0,this.range=d,this.matches=S}}n.FindMatch=L;var m;(function(a){a[a.Disabled=0]="Disabled",a[a.EnabledForActive=1]="EnabledForActive",a[a.Enabled=2]="Enabled"})(m=n.HorizontalGuidesState||(n.HorizontalGuidesState={}));class u{constructor(d,S,b){this.visibleColumn=d,this.className=S,this.horizontalLine=b}}n.IndentGuide=u;class h{constructor(d,S){this.top=d,this.endColumn=S}}n.IndentGuideHorizontalLine=h;class C{constructor(d,S,b,v,w,p){this.identifier=d,this.range=S,this.text=b,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=w,this._isTracked=p}}n.ValidAnnotatedEditOperation=C;class e{constructor(d,S,b){this.reverseEdits=d,this.changes=S,this.trimAutoWhitespaceLineNumbers=b}}n.ApplyEditsResult=e}),$(j[31],G([0,1,3,26,4,5,30]),function(I,n,M,R,E,o,L){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.SearchData=n.isMultilineRegexSource=n.SearchParams=void 0;const m=999;class u{constructor(r,i,s,c){this.searchString=r,this.isRegex=i,this.matchCase=s,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let r;this.isRegex?r=h(this.searchString):r=this.searchString.indexOf(`
`)>=0;let i=null;try{i=M.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:r,global:!0,unicode:!0})}catch(c){return null}if(!i)return null;let s=!this.isRegex&&!r;return s&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(s=this.matchCase),new C(i,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,s?this.searchString:null)}}n.SearchParams=u;function h(p){if(!p||p.length===0)return!1;for(let r=0,i=p.length;r<i;r++)if(p.charCodeAt(r)===92){if(r++,r>=i)break;const c=p.charCodeAt(r);if(c===110||c===114||c===87)return!0}return!1}n.isMultilineRegexSource=h;class C{constructor(r,i,s){this.regex=r,this.wordSeparators=i,this.simpleSearch=s}}n.SearchData=C;function e(p,r,i){if(!i)return new L.FindMatch(p,null);let s=[];for(let c=0,g=r.length;c<g;c++)s[c]=r[c];return new L.FindMatch(p,s)}n.createFindMatch=e;class a{constructor(r){let i=[],s=0;for(let c=0,g=r.length;c<g;c++)r.charCodeAt(c)===10&&(i[s++]=c);this._lineFeedsOffsets=i}findLineFeedCountBeforeOffset(r){const i=this._lineFeedsOffsets;let s=0,c=i.length-1;if(c===-1||r<=i[0])return 0;for(;s<c;){const g=s+((c-s)/2>>0);i[g]>=r?c=g-1:i[g+1]>=r?(s=g,c=g):s=g+1}return s+1}}class d{static findMatches(r,i,s,c,g){const l=i.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(r,s,new w(l.wordSeparators,l.regex),c,g):this._doFindMatchesLineByLine(r,s,l,c,g):[]}static _getMultilineMatchRange(r,i,s,c,g,l){let _,f=0;c?(f=c.findLineFeedCountBeforeOffset(g),_=i+g+f):_=i+g;let N;if(c){let k=c.findLineFeedCountBeforeOffset(g+l.length)-f;N=_+l.length+k}else N=_+l.length;const A=r.getPositionAt(_),y=r.getPositionAt(N);return new o.Range(A.lineNumber,A.column,y.lineNumber,y.column)}static _doFindMatchesMultiline(r,i,s,c,g){const l=r.getOffsetAt(i.getStartPosition()),_=r.getValueInRange(i,1),f=r.getEOL()===`\r
`?new a(_):null,N=[];let A=0,y;for(s.reset(0);y=s.next(_);)if(N[A++]=e(this._getMultilineMatchRange(r,l,_,f,y.index,y[0]),y,c),A>=g)return N;return N}static _doFindMatchesLineByLine(r,i,s,c,g){const l=[];let _=0;if(i.startLineNumber===i.endLineNumber){const N=r.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return _=this._findMatchesInLine(s,N,i.startLineNumber,i.startColumn-1,_,l,c,g),l}const f=r.getLineContent(i.startLineNumber).substring(i.startColumn-1);_=this._findMatchesInLine(s,f,i.startLineNumber,i.startColumn-1,_,l,c,g);for(let N=i.startLineNumber+1;N<i.endLineNumber&&_<g;N++)_=this._findMatchesInLine(s,r.getLineContent(N),N,0,_,l,c,g);if(_<g){const N=r.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);_=this._findMatchesInLine(s,N,i.endLineNumber,0,_,l,c,g)}return l}static _findMatchesInLine(r,i,s,c,g,l,_,f){const N=r.wordSeparators;if(!_&&r.simpleSearch){const D=r.simpleSearch,k=D.length,B=i.length;let U=-k;for(;(U=i.indexOf(D,U+k))!==-1;)if((!N||v(N,i,B,U,k))&&(l[g++]=new L.FindMatch(new o.Range(s,U+1+c,s,U+1+k+c),null),g>=f))return g;return g}const A=new w(r.wordSeparators,r.regex);let y;A.reset(0);do if(y=A.next(i),y&&(l[g++]=e(new o.Range(s,y.index+1+c,s,y.index+1+y[0].length+c),y,_),g>=f))return g;while(y);return g}static findNextMatch(r,i,s,c){const g=i.parseSearchRequest();if(!g)return null;const l=new w(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindNextMatchMultiline(r,s,l,c):this._doFindNextMatchLineByLine(r,s,l,c)}static _doFindNextMatchMultiline(r,i,s,c){const g=new E.Position(i.lineNumber,1),l=r.getOffsetAt(g),_=r.getLineCount(),f=r.getValueInRange(new o.Range(g.lineNumber,g.column,_,r.getLineMaxColumn(_)),1),N=r.getEOL()===`\r
`?new a(f):null;s.reset(i.column-1);let A=s.next(f);return A?e(this._getMultilineMatchRange(r,l,f,N,A.index,A[0]),A,c):i.lineNumber!==1||i.column!==1?this._doFindNextMatchMultiline(r,new E.Position(1,1),s,c):null}static _doFindNextMatchLineByLine(r,i,s,c){const g=r.getLineCount(),l=i.lineNumber,_=r.getLineContent(l),f=this._findFirstMatchInLine(s,_,l,i.column,c);if(f)return f;for(let N=1;N<=g;N++){const A=(l+N-1)%g,y=r.getLineContent(A+1),D=this._findFirstMatchInLine(s,y,A+1,1,c);if(D)return D}return null}static _findFirstMatchInLine(r,i,s,c,g){r.reset(c-1);const l=r.next(i);return l?e(new o.Range(s,l.index+1,s,l.index+1+l[0].length),l,g):null}static findPreviousMatch(r,i,s,c){const g=i.parseSearchRequest();if(!g)return null;const l=new w(g.wordSeparators,g.regex);return g.regex.multiline?this._doFindPreviousMatchMultiline(r,s,l,c):this._doFindPreviousMatchLineByLine(r,s,l,c)}static _doFindPreviousMatchMultiline(r,i,s,c){const g=this._doFindMatchesMultiline(r,new o.Range(1,1,i.lineNumber,i.column),s,c,10*m);if(g.length>0)return g[g.length-1];const l=r.getLineCount();return i.lineNumber!==l||i.column!==r.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(r,new E.Position(l,r.getLineMaxColumn(l)),s,c):null}static _doFindPreviousMatchLineByLine(r,i,s,c){const g=r.getLineCount(),l=i.lineNumber,_=r.getLineContent(l).substring(0,i.column-1),f=this._findLastMatchInLine(s,_,l,c);if(f)return f;for(let N=1;N<=g;N++){const A=(g+l-N-1)%g,y=r.getLineContent(A+1),D=this._findLastMatchInLine(s,y,A+1,c);if(D)return D}return null}static _findLastMatchInLine(r,i,s,c){let g=null,l;for(r.reset(0);l=r.next(i);)g=e(new o.Range(s,l.index+1,s,l.index+1+l[0].length),l,c);return g}}n.TextModelSearch=d;function S(p,r,i,s,c){if(s===0)return!0;const g=r.charCodeAt(s-1);if(p.get(g)!==0||g===13||g===10)return!0;if(c>0){const l=r.charCodeAt(s);if(p.get(l)!==0)return!0}return!1}function b(p,r,i,s,c){if(s+c===i)return!0;const g=r.charCodeAt(s+c);if(p.get(g)!==0||g===13||g===10)return!0;if(c>0){const l=r.charCodeAt(s+c-1);if(p.get(l)!==0)return!0}return!1}function v(p,r,i,s,c){return S(p,r,i,s,c)&&b(p,r,i,s,c)}n.isValidMatch=v;class w{constructor(r,i){this._wordSeparators=r,this._searchRegex=i,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(r){this._searchRegex.lastIndex=r,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(r){const i=r.length;let s;do{if(this._prevMatchStartIndex+this._prevMatchLength===i||(s=this._searchRegex.exec(r),!s))return null;const c=s.index,g=s[0].length;if(c===this._prevMatchStartIndex&&g===this._prevMatchLength){if(g===0){M.getNextCodePoint(r,i,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=c,this._prevMatchLength=g,!this._wordSeparators||v(this._wordSeparators,r,i,c,g))return s}while(s);return null}}n.Searcher=w}),$(j[32],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function M(m=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const h of n.USUAL_WORD_SEPARATORS)m.indexOf(h)>=0||(u+="\\"+h);return u+="\\s]+)",new RegExp(u,"g")}n.DEFAULT_WORD_REGEXP=M();function R(m){let u=n.DEFAULT_WORD_REGEXP;if(m&&m instanceof RegExp)if(m.global)u=m;else{let h="g";m.ignoreCase&&(h+="i"),m.multiline&&(h+="m"),m.unicode&&(h+="u"),u=new RegExp(m.source,h)}return u.lastIndex=0,u}n.ensureValidWordDefinition=R;const E={maxLen:1e3,windowSize:15,timeBudget:150};function o(m,u,h,C,e=E){if(h.length>e.maxLen){let v=m-e.maxLen/2;return v<0?v=0:C+=v,h=h.substring(v,m+e.maxLen/2),o(m,u,h,C,e)}const a=Date.now(),d=m-1-C;let S=-1,b=null;for(let v=1;!(Date.now()-a>=e.timeBudget);v++){const w=d-e.windowSize*v;u.lastIndex=Math.max(0,w);const p=L(u,h,d,S);if(!p&&b||(b=p,w<=0))break;S=w}if(b){let v={word:b[0],startColumn:C+1+b.index,endColumn:C+1+b.index+b[0].length};return u.lastIndex=0,v}return null}n.getWordAtText=o;function L(m,u,h,C){let e;for(;e=m.exec(u);){const a=e.index||0;if(a<=h&&m.lastIndex>=h)return e;if(C>0&&a>C)return null}return null}}),$(j[33],G([0,1,14]),function(I,n,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=n.Uint8Matrix=void 0;class R{constructor(a,d,S){const b=new Uint8Array(a*d);for(let v=0,w=a*d;v<w;v++)b[v]=S;this._data=b,this.rows=a,this.cols=d}get(a,d){return this._data[a*this.cols+d]}set(a,d,S){this._data[a*this.cols+d]=S}}n.Uint8Matrix=R;class E{constructor(a){let d=0,S=0;for(let v=0,w=a.length;v<w;v++){let[p,r,i]=a[v];r>d&&(d=r),p>S&&(S=p),i>S&&(S=i)}d++,S++;let b=new R(S,d,0);for(let v=0,w=a.length;v<w;v++){let[p,r,i]=a[v];b.set(p,r,i)}this._states=b,this._maxCharCode=d}nextState(a,d){return d<0||d>=this._maxCharCode?0:this._states.get(a,d)}}n.StateMachine=E;let o=null;function L(){return o===null&&(o=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),o}let m=null;function u(){if(m===null){m=new M.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<e.length;d++)m.set(e.charCodeAt(d),1);const a=".,;";for(let d=0;d<a.length;d++)m.set(a.charCodeAt(d),2)}return m}class h{static _createLink(a,d,S,b,v){let w=v-1;do{const p=d.charCodeAt(w);if(a.get(p)!==2)break;w--}while(w>b);if(b>0){const p=d.charCodeAt(b-1),r=d.charCodeAt(w);(p===40&&r===41||p===91&&r===93||p===123&&r===125)&&w--}return{range:{startLineNumber:S,startColumn:b+1,endLineNumber:S,endColumn:w+2},url:d.substring(b,w+1)}}static computeLinks(a,d=L()){const S=u();let b=[];for(let v=1,w=a.getLineCount();v<=w;v++){const p=a.getLineContent(v),r=p.length;let i=0,s=0,c=0,g=1,l=!1,_=!1,f=!1,N=!1;for(;i<r;){let A=!1;const y=p.charCodeAt(i);if(g===13){let D;switch(y){case 40:l=!0,D=0;break;case 41:D=l?0:1;break;case 91:f=!0,_=!0,D=0;break;case 93:f=!1,D=_?0:1;break;case 123:N=!0,D=0;break;case 125:D=N?0:1;break;case 39:D=c===34||c===96?0:1;break;case 34:D=c===39||c===96?0:1;break;case 96:D=c===39||c===34?0:1;break;case 42:D=c===42?1:0;break;case 124:D=c===124?1:0;break;case 32:D=f?0:1;break;default:D=S.get(y)}D===1&&(b.push(h._createLink(S,p,v,s,i)),A=!0)}else if(g===12){let D;y===91?(_=!0,D=0):D=S.get(y),D===1?A=!0:g=13}else g=d.nextState(g,y),g===0&&(A=!0);A&&(g=1,l=!1,_=!1,N=!1,s=i+1,c=y),i++}g===13&&b.push(h._createLink(S,p,v,s,r))}return b}}n.LinkComputer=h;function C(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:h.computeLinks(e)}n.computeLinks=C}),$(j[34],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class M{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(E,o,L,m,u){if(E&&o){let h=this.doNavigateValueSet(o,u);if(h)return{range:E,value:h}}if(L&&m){let h=this.doNavigateValueSet(m,u);if(h)return{range:L,value:h}}return null}doNavigateValueSet(E,o){let L=this.numberReplace(E,o);return L!==null?L:this.textReplace(E,o)}numberReplace(E,o){let L=Math.pow(10,E.length-(E.lastIndexOf(".")+1)),m=Number(E),u=parseFloat(E);return!isNaN(m)&&!isNaN(u)&&m===u?m===0&&!o?null:(m=Math.floor(m*L),m+=o?L:-L,String(m/L)):null}textReplace(E,o){return this.valueSetsReplace(this._defaultValueSet,E,o)}valueSetsReplace(E,o,L){let m=null;for(let u=0,h=E.length;m===null&&u<h;u++)m=this.valueSetReplace(E[u],o,L);return m}valueSetReplace(E,o,L){let m=E.indexOf(o);return m>=0?(m+=L?1:-1,m<0?m=E.length-1:m%=E.length,E[m]):null}}n.BasicInplaceReplace=M,M.INSTANCE=new M}),$(j[35],G([0,1,5,31,3]),function(I,n,M,R,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class o{static computeUnicodeHighlights(h,C,e){const a=e?e.startLineNumber:1,d=e?e.endLineNumber:h.getLineCount(),S=new m(C),b=S.getCandidateCodePoints();let v;b==="allNonBasicAscii"?v=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):v=new RegExp(`${L(Array.from(b))}`,"g");const w=new R.Searcher(null,v),p=[];let r;for(let i=a,s=d;i<=s;i++){const c=h.getLineContent(i),g=c.length;w.reset(0);do if(r=w.next(c),r){let l=r.index,_=r.index+r[0].length;if(l>0){const N=c.charCodeAt(l-1);E.isHighSurrogate(N)&&l--}if(_+1<g){const N=c.charCodeAt(_-1);E.isHighSurrogate(N)&&_++}const f=c.substring(l,_);if(S.shouldHighlightNonBasicASCII(f)!==0){p.push(new M.Range(i,l+1,i,_+1));const N=1e3;if(p.length>N)break}}while(r)}return p}static computeUnicodeHighlightReason(h,C){switch(new m(C).shouldHighlightNonBasicASCII(h)){case 0:return null;case 2:return{kind:1};case 3:const d=E.AmbiguousCharacters.getPrimaryConfusable(h.codePointAt(0));return{kind:0,confusableWith:String.fromCodePoint(d)};case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=o;function L(u,h){return`[${E.escapeRegExpCharacters(u.map(e=>String.fromCodePoint(e)).join(""))}]`}class m{constructor(h){this.options=h,this.allowedCodePoints=new Set(h.allowedCodePoints)}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const h=new Set;if(this.options.invisibleCharacters)for(const C of E.InvisibleCharacters.codePoints)h.add(C);if(this.options.ambiguousCharacters)for(const C of E.AmbiguousCharacters.getPrimaryConfusableCodePoints())h.add(C);for(const C of this.allowedCodePoints)h.delete(C);return h}shouldHighlightNonBasicASCII(h){const C=h.codePointAt(0);return this.allowedCodePoints.has(C)?0:this.options.nonBasicASCII?1:this.options.invisibleCharacters&&!(h===" "||h===`
`||h==="	")&&E.InvisibleCharacters.isInvisibleCharacter(C)?2:this.options.ambiguousCharacters&&E.AmbiguousCharacters.isAmbiguous(C)?3:0}}}),$(j[36],G([0,1]),function(I,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.AccessibilitySupport=void 0;var M;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(M=n.AccessibilitySupport||(n.AccessibilitySupport={}));var R;(function(t){t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(R=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var E;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(E=n.CompletionItemKind||(n.CompletionItemKind={}));var o;(function(t){t[t.Deprecated=1]="Deprecated"})(o=n.CompletionItemTag||(n.CompletionItemTag={}));var L;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var m;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(m=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var u;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(u=n.CursorChangeReason||(n.CursorChangeReason={}));var h;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(h=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var C;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(C=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var e;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(e=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var a;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.autoClosingDelete=6]="autoClosingDelete",t[t.autoClosingOvertype=7]="autoClosingOvertype",t[t.autoClosingQuotes=8]="autoClosingQuotes",t[t.autoIndent=9]="autoIndent",t[t.automaticLayout=10]="automaticLayout",t[t.autoSurround=11]="autoSurround",t[t.bracketPairColorization=12]="bracketPairColorization",t[t.guides=13]="guides",t[t.codeLens=14]="codeLens",t[t.codeLensFontFamily=15]="codeLensFontFamily",t[t.codeLensFontSize=16]="codeLensFontSize",t[t.colorDecorators=17]="colorDecorators",t[t.columnSelection=18]="columnSelection",t[t.comments=19]="comments",t[t.contextmenu=20]="contextmenu",t[t.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",t[t.cursorBlinking=22]="cursorBlinking",t[t.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",t[t.cursorStyle=24]="cursorStyle",t[t.cursorSurroundingLines=25]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",t[t.cursorWidth=27]="cursorWidth",t[t.disableLayerHinting=28]="disableLayerHinting",t[t.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",t[t.domReadOnly=30]="domReadOnly",t[t.dragAndDrop=31]="dragAndDrop",t[t.emptySelectionClipboard=32]="emptySelectionClipboard",t[t.extraEditorClassName=33]="extraEditorClassName",t[t.fastScrollSensitivity=34]="fastScrollSensitivity",t[t.find=35]="find",t[t.fixedOverflowWidgets=36]="fixedOverflowWidgets",t[t.folding=37]="folding",t[t.foldingStrategy=38]="foldingStrategy",t[t.foldingHighlight=39]="foldingHighlight",t[t.foldingImportsByDefault=40]="foldingImportsByDefault",t[t.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=42]="fontFamily",t[t.fontInfo=43]="fontInfo",t[t.fontLigatures=44]="fontLigatures",t[t.fontSize=45]="fontSize",t[t.fontWeight=46]="fontWeight",t[t.formatOnPaste=47]="formatOnPaste",t[t.formatOnType=48]="formatOnType",t[t.glyphMargin=49]="glyphMargin",t[t.gotoLocation=50]="gotoLocation",t[t.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",t[t.hover=52]="hover",t[t.inDiffEditor=53]="inDiffEditor",t[t.inlineSuggest=54]="inlineSuggest",t[t.letterSpacing=55]="letterSpacing",t[t.lightbulb=56]="lightbulb",t[t.lineDecorationsWidth=57]="lineDecorationsWidth",t[t.lineHeight=58]="lineHeight",t[t.lineNumbers=59]="lineNumbers",t[t.lineNumbersMinChars=60]="lineNumbersMinChars",t[t.linkedEditing=61]="linkedEditing",t[t.links=62]="links",t[t.matchBrackets=63]="matchBrackets",t[t.minimap=64]="minimap",t[t.mouseStyle=65]="mouseStyle",t[t.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=67]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",t[t.multiCursorModifier=69]="multiCursorModifier",t[t.multiCursorPaste=70]="multiCursorPaste",t[t.occurrencesHighlight=71]="occurrencesHighlight",t[t.overviewRulerBorder=72]="overviewRulerBorder",t[t.overviewRulerLanes=73]="overviewRulerLanes",t[t.padding=74]="padding",t[t.parameterHints=75]="parameterHints",t[t.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",t[t.quickSuggestions=78]="quickSuggestions",t[t.quickSuggestionsDelay=79]="quickSuggestionsDelay",t[t.readOnly=80]="readOnly",t[t.renameOnType=81]="renameOnType",t[t.renderControlCharacters=82]="renderControlCharacters",t[t.renderFinalNewline=83]="renderFinalNewline",t[t.renderLineHighlight=84]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=86]="renderValidationDecorations",t[t.renderWhitespace=87]="renderWhitespace",t[t.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",t[t.roundedSelection=89]="roundedSelection",t[t.rulers=90]="rulers",t[t.scrollbar=91]="scrollbar",t[t.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=93]="scrollBeyondLastLine",t[t.scrollPredominantAxis=94]="scrollPredominantAxis",t[t.selectionClipboard=95]="selectionClipboard",t[t.selectionHighlight=96]="selectionHighlight",t[t.selectOnLineNumbers=97]="selectOnLineNumbers",t[t.showFoldingControls=98]="showFoldingControls",t[t.showUnused=99]="showUnused",t[t.snippetSuggestions=100]="snippetSuggestions",t[t.smartSelect=101]="smartSelect",t[t.smoothScrolling=102]="smoothScrolling",t[t.stickyTabStops=103]="stickyTabStops",t[t.stopRenderingLineAfter=104]="stopRenderingLineAfter",t[t.suggest=105]="suggest",t[t.suggestFontSize=106]="suggestFontSize",t[t.suggestLineHeight=107]="suggestLineHeight",t[t.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",t[t.suggestSelection=109]="suggestSelection",t[t.tabCompletion=110]="tabCompletion",t[t.tabIndex=111]="tabIndex",t[t.unicodeHighlighting=112]="unicodeHighlighting",t[t.unusualLineTerminators=113]="unusualLineTerminators",t[t.useShadowDOM=114]="useShadowDOM",t[t.useTabStops=115]="useTabStops",t[t.wordSeparators=116]="wordSeparators",t[t.wordWrap=117]="wordWrap",t[t.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=120]="wordWrapColumn",t[t.wordWrapOverride1=121]="wordWrapOverride1",t[t.wordWrapOverride2=122]="wordWrapOverride2",t[t.wrappingIndent=123]="wrappingIndent",t[t.wrappingStrategy=124]="wrappingStrategy",t[t.showDeprecated=125]="showDeprecated",t[t.inlayHints=126]="inlayHints",t[t.editorClassName=127]="editorClassName",t[t.pixelRatio=128]="pixelRatio",t[t.tabFocusMode=129]="tabFocusMode",t[t.layoutInfo=130]="layoutInfo",t[t.wrappingInfo=131]="wrappingInfo"})(a=n.EditorOption||(n.EditorOption={}));var d;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(d=n.EndOfLinePreference||(n.EndOfLinePreference={}));var S;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(S=n.EndOfLineSequence||(n.EndOfLineSequence={}));var b;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(b=n.IndentAction||(n.IndentAction={}));var v;(function(t){t[t.Other=0]="Other",t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(v=n.InlayHintKind||(n.InlayHintKind={}));var w;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(w=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=n.KeyCode||(n.KeyCode={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r=n.MarkerSeverity||(n.MarkerSeverity={}));var i;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(i=n.MarkerTag||(n.MarkerTag={}));var s;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(s=n.MinimapPosition||(n.MinimapPosition={}));var c;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(c=n.MouseTargetType||(n.MouseTargetType={}));var g;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(g=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var l;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(l=n.OverviewRulerLane||(n.OverviewRulerLane={}));var _;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(_=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var f;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(f=n.RenderMinimap||(n.RenderMinimap={}));var N;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(N=n.ScrollType||(n.ScrollType={}));var A;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(A=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var y;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(y=n.SelectionDirection||(n.SelectionDirection={}));var D;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(D=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var k;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(k=n.SymbolKind||(n.SymbolKind={}));var B;(function(t){t[t.Deprecated=1]="Deprecated"})(B=n.SymbolTag||(n.SymbolTag={}));var U;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(U=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var T;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(T=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var H;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(H=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var W;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(W=n.WrappingIndent||(n.WrappingIndent={}))}),$(j[37],G([0,1,23,6,19,13,4,5,27,28,36]),function(I,n,M,R,E,o,L,m,u,h,C){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(S,b){return(0,E.KeyChord)(S,b)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function a(){return{editor:void 0,languages:void 0,CancellationTokenSource:M.CancellationTokenSource,Emitter:R.Emitter,KeyCode:C.KeyCode,KeyMod:e,Position:L.Position,Range:m.Range,Selection:u.Selection,SelectionDirection:C.SelectionDirection,MarkerSeverity:C.MarkerSeverity,MarkerTag:C.MarkerTag,Uri:o.URI,Token:h.Token}}n.createMonacoBaseAPI=a}),$(j[38],G([0,1,15,12]),function(I,n,M,R){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class E{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(u,h){u=(0,R.toUint32)(u);const C=this.values,e=this.prefixSum,a=h.length;return a===0?!1:(this.values=new Uint32Array(C.length+a),this.values.set(C.subarray(0,u),0),this.values.set(C.subarray(u),u+a),this.values.set(h,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,h){return u=(0,R.toUint32)(u),h=(0,R.toUint32)(h),this.values[u]===h?!1:(this.values[u]=h,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,h){u=(0,R.toUint32)(u),h=(0,R.toUint32)(h);const C=this.values,e=this.prefixSum;if(u>=C.length)return!1;let a=C.length-u;return h>=a&&(h=a),h===0?!1:(this.values=new Uint32Array(C.length-h),this.values.set(C.subarray(0,u),0),this.values.set(C.subarray(u+h),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,R.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let h=this.prefixSumValidIndex[0]+1;h===0&&(this.prefixSum[0]=this.values[0],h++),u>=this.values.length&&(u=this.values.length-1);for(let C=h;C<=u;C++)this.prefixSum[C]=this.prefixSum[C-1]+this.values[C];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let h=0,C=this.values.length-1,e=0,a=0,d=0;for(;h<=C;)if(e=h+(C-h)/2|0,a=this.prefixSum[e],d=a-this.values[e],u<d)C=e-1;else if(u>=a)h=e+1;else break;return new L(e,u-d)}}n.PrefixSumComputer=E;class o{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const h=this._indexBySum[u],C=h>0?this._prefixSum[h-1]:0;return new L(h,u-C)}removeValues(u,h){this._values.splice(u,h),this._invalidate(u)}insertValues(u,h){this._values=(0,M.arrayInsert)(this._values,u,h),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,h=this._values.length;u<h;u++){const C=this._values[u],e=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=e+C;for(let a=0;a<C;a++)this._indexBySum[e+a]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,h){this._values[u]!==h&&(this._values[u]=h,this._invalidate(u))}}n.ConstantTimePrefixSumComputer=o;class L{constructor(u,h){this.index=u,this.remainder=h,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=h}}n.PrefixSumIndexOfResult=L}),$(j[39],G([0,1,3,4,38]),function(I,n,M,R,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class o{constructor(m,u,h,C){this._uri=m,this._lines=u,this._eol=h,this._versionId=C,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(m){m.eol&&m.eol!==this._eol&&(this._eol=m.eol,this._lineStarts=null);const u=m.changes;for(const h of u)this._acceptDeleteRange(h.range),this._acceptInsertText(new R.Position(h.range.startLineNumber,h.range.startColumn),h.text);this._versionId=m.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const m=this._eol.length,u=this._lines.length,h=new Uint32Array(u);for(let C=0;C<u;C++)h[C]=this._lines[C].length+m;this._lineStarts=new E.PrefixSumComputer(h)}}_setLineText(m,u){this._lines[m]=u,this._lineStarts&&this._lineStarts.setValue(m,this._lines[m].length+this._eol.length)}_acceptDeleteRange(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.startLineNumber-1].substring(m.endColumn-1));return}this._setLineText(m.startLineNumber-1,this._lines[m.startLineNumber-1].substring(0,m.startColumn-1)+this._lines[m.endLineNumber-1].substring(m.endColumn-1)),this._lines.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}_acceptInsertText(m,u){if(u.length===0)return;let h=(0,M.splitLines)(u);if(h.length===1){this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+h[0]+this._lines[m.lineNumber-1].substring(m.column-1));return}h[h.length-1]+=this._lines[m.lineNumber-1].substring(m.column-1),this._setLineText(m.lineNumber-1,this._lines[m.lineNumber-1].substring(0,m.column-1)+h[0]);let C=new Uint32Array(h.length-1);for(let e=1;e<h.length;e++)this._lines.splice(m.lineNumber+e-1,0,h[e]),C[e-1]=h[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(m.lineNumber,C)}}n.MirrorTextModel=o});var ie=this&&this.__awaiter||function(I,n,M,R){function E(o){return o instanceof M?o:new M(function(L){L(o)})}return new(M||(M=Promise))(function(o,L){function m(C){try{h(R.next(C))}catch(e){L(e)}}function u(C){try{h(R.throw(C))}catch(e){L(e)}}function h(C){C.done?o(C.value):E(C.value).then(m,u)}h((R=R.apply(I,n||[])).next())})};$(j[41],G([0,1,11,2,13,4,5,29,39,32,33,34,37,7,10,35]),function(I,n,M,R,E,o,L,m,u,h,C,e,a,d,S,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=n.MirrorModel=void 0;class v extends u.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(i){return this._lines[i-1]}getWordAtPosition(i,s){let c=(0,h.getWordAtText)(i.column,(0,h.ensureValidWordDefinition)(s),this._lines[i.lineNumber-1],0);return c?new L.Range(i.lineNumber,c.startColumn,i.lineNumber,c.endColumn):null}words(i){const s=this._lines,c=this._wordenize.bind(this);let g=0,l="",_=0,f=[];return{*[Symbol.iterator](){for(;;)if(_<f.length){const N=l.substring(f[_].start,f[_].end);_+=1,yield N}else if(g<s.length)l=s[g],f=c(l,i),_=0,g+=1;else break}}}getLineWords(i,s){let c=this._lines[i-1],g=this._wordenize(c,s),l=[];for(const _ of g)l.push({word:c.substring(_.start,_.end),startColumn:_.start+1,endColumn:_.end+1});return l}_wordenize(i,s){const c=[];let g;for(s.lastIndex=0;(g=s.exec(i))&&g[0].length!==0;)c.push({start:g.index,end:g.index+g[0].length});return c}getValueInRange(i){if(i=this._validateRange(i),i.startLineNumber===i.endLineNumber)return this._lines[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);let s=this._eol,c=i.startLineNumber-1,g=i.endLineNumber-1,l=[];l.push(this._lines[c].substring(i.startColumn-1));for(let _=c+1;_<g;_++)l.push(this._lines[_]);return l.push(this._lines[g].substring(0,i.endColumn-1)),l.join(s)}offsetAt(i){return i=this._validatePosition(i),this._ensureLineStarts(),this._lineStarts.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this._ensureLineStarts();let s=this._lineStarts.getIndexOf(i),c=this._lines[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,c)}}_validateRange(i){const s=this._validatePosition({lineNumber:i.startLineNumber,column:i.startColumn}),c=this._validatePosition({lineNumber:i.endLineNumber,column:i.endColumn});return s.lineNumber!==i.startLineNumber||s.column!==i.startColumn||c.lineNumber!==i.endLineNumber||c.column!==i.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:c.lineNumber,endColumn:c.column}:i}_validatePosition(i){if(!o.Position.isIPosition(i))throw new Error("bad position");let{lineNumber:s,column:c}=i,g=!1;if(s<1)s=1,c=1,g=!0;else if(s>this._lines.length)s=this._lines.length,c=this._lines[s-1].length+1,g=!0;else{let l=this._lines[s-1].length+1;c<1?(c=1,g=!0):c>l&&(c=l,g=!0)}return g?{lineNumber:s,column:c}:i}}n.MirrorModel=v;class w{constructor(i,s){this._host=i,this._models=Object.create(null),this._foreignModuleFactory=s,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(i){return this._models[i]}_getModels(){let i=[];return Object.keys(this._models).forEach(s=>i.push(this._models[s])),i}acceptNewModel(i){this._models[i.url]=new v(E.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,s){if(!this._models[i])return;this._models[i].onEvents(s)}acceptRemovedModel(i){!this._models[i]||delete this._models[i]}computeUnicodeHighlights(i,s,c){return ie(this,void 0,void 0,function*(){const g=this._getModel(i);return g?b.UnicodeTextModelHighlighter.computeUnicodeHighlights(g,s,c):[]})}computeDiff(i,s,c,g){return ie(this,void 0,void 0,function*(){const l=this._getModel(i),_=this._getModel(s);if(!l||!_)return null;const f=l.getLinesContent(),N=_.getLinesContent(),y=new m.DiffComputer(f,N,{shouldComputeCharChanges:!0,shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:c,shouldMakePrettyDiff:!0,maxComputationTime:g}).computeDiff(),D=y.changes.length>0?!1:this._modelsAreIdentical(l,_);return{quitEarly:y.quitEarly,identical:D,changes:y.changes}})}_modelsAreIdentical(i,s){const c=i.getLineCount(),g=s.getLineCount();if(c!==g)return!1;for(let l=1;l<=c;l++){const _=i.getLineContent(l),f=s.getLineContent(l);if(_!==f)return!1}return!0}computeMoreMinimalEdits(i,s){return ie(this,void 0,void 0,function*(){const c=this._getModel(i);if(!c)return s;const g=[];let l;s=s.slice(0).sort((_,f)=>{if(_.range&&f.range)return L.Range.compareRangesUsingStarts(_.range,f.range);let N=_.range?0:1,A=f.range?0:1;return N-A});for(let{range:_,text:f,eol:N}of s){if(typeof N=="number"&&(l=N),L.Range.isEmpty(_)&&!f)continue;const A=c.getValueInRange(_);if(f=f.replace(/\r\n|\n|\r/g,c.eol),A===f)continue;if(Math.max(f.length,A.length)>w._diffLimit){g.push({range:_,text:f});continue}const y=(0,M.stringDiff)(A,f,!1),D=c.offsetAt(L.Range.lift(_).getStartPosition());for(const k of y){const B=c.positionAt(D+k.originalStart),U=c.positionAt(D+k.originalStart+k.originalLength),T={text:f.substr(k.modifiedStart,k.modifiedLength),range:{startLineNumber:B.lineNumber,startColumn:B.column,endLineNumber:U.lineNumber,endColumn:U.column}};c.getValueInRange(T.range)!==T.text&&g.push(T)}}return typeof l=="number"&&g.push({eol:l,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),g})}computeLinks(i){return ie(this,void 0,void 0,function*(){let s=this._getModel(i);return s?(0,C.computeLinks)(s):null})}textualSuggest(i,s,c,g){return ie(this,void 0,void 0,function*(){const l=new S.StopWatch(!0),_=new RegExp(c,g),f=new Set;e:for(let N of i){const A=this._getModel(N);if(!!A){for(let y of A.words(_))if(!(y===s||!isNaN(Number(y)))&&(f.add(y),f.size>w._suggestionsLimit))break e}}return{words:Array.from(f),duration:l.elapsed()}})}computeWordRanges(i,s,c,g){return ie(this,void 0,void 0,function*(){let l=this._getModel(i);if(!l)return Object.create(null);const _=new RegExp(c,g),f=Object.create(null);for(let N=s.startLineNumber;N<s.endLineNumber;N++){let A=l.getLineWords(N,_);for(const y of A){if(!isNaN(Number(y.word)))continue;let D=f[y.word];D||(D=[],f[y.word]=D),D.push({startLineNumber:N,startColumn:y.startColumn,endLineNumber:N,endColumn:y.endColumn})}}return f})}navigateValueSet(i,s,c,g,l){return ie(this,void 0,void 0,function*(){let _=this._getModel(i);if(!_)return null;let f=new RegExp(g,l);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});let N=_.getValueInRange(s),A=_.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},f);if(!A)return null;let y=_.getValueInRange(A);return e.BasicInplaceReplace.INSTANCE.navigateValueSet(s,N,A,y,c)})}loadForeignModule(i,s,c){const g=(f,N)=>this._host.fhr(f,N);let _={host:d.createProxyObject(c,g),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(_,s),Promise.resolve(d.getAllMethodNames(this._foreignModule))):new Promise((f,N)=>{I([i],A=>{this._foreignModule=A.create(_,s),f(d.getAllMethodNames(this._foreignModule))},N)})}fmr(i,s){if(!this._foreignModule||typeof this._foreignModule[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._foreignModule[i].apply(this._foreignModule,s))}catch(c){return Promise.reject(c)}}}n.EditorSimpleWorker=w,w._diffLimit=1e5,w._suggestionsLimit=1e4;function p(r){return new w(r,null)}n.create=p,typeof importScripts=="function"&&(R.globals.monaco=(0,a.createMonacoBaseAPI)())}),function(){var I,n;const M=self.MonacoEnvironment,R=M&&M.baseUrl?M.baseUrl:"../../../",E=typeof((I=self.trustedTypes)===null||I===void 0?void 0:I.createPolicy)=="function"?(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("amdLoader",{createScriptURL:C=>C,createScript:(C,...e)=>{const a=e.slice(0,-1).join(","),d=e.pop().toString();return`(function anonymous(${a}) {
${d}
})`}}):void 0;function o(){try{return(E?self.eval(E.createScript("","true")):new Function("true")).call(self),!0}catch(C){return!1}}function L(){return new Promise((C,e)=>{if(typeof self.define=="function"&&self.define.amd)return C();const a=R+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(a)&&a.substring(0,self.origin.length)!==self.origin)&&o()){fetch(a).then(S=>{if(S.status!==200)throw new Error(S.statusText);return S.text()}).then(S=>{S=`${S}
//# sourceURL=${a}`,(E?self.eval(E.createScript("",S)):new Function(S)).call(self),C()}).then(void 0,e);return}E?importScripts(E.createScriptURL(a)):importScripts(a),C()})}const m=function(C){L().then(()=>{require.config({baseUrl:R,catchError:!0,trustedTypesPolicy:E,amdModulesPattern:/^vs\//}),require([C],function(e){setTimeout(function(){let a=e.create((d,S)=>{self.postMessage(d,S)},null);for(self.onmessage=d=>a.onmessage(d.data,d.ports);h.length>0;)self.onmessage(h.shift())},0)})})};let u=!0,h=[];self.onmessage=C=>{if(!u){h.push(C);return}u=!1,m(C.data)}}()}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map